// ============================================================================
#ifndef CALOPIDS_TOVECTOR_H 
#define CALOPIDS_TOVECTOR_H 1
// ============================================================================
// Include files
// ============================================================================
// STD & STL 
// ============================================================================
#include <vector>
#include <type_traits>
#include <string>
// ============================================================================
// Local 
// ============================================================================
#include "ToString.h"
// ============================================================================

namespace Gaudi
{
  namespace Utils 
  {
    // ========================================================================
    template <typename... TYPE>
    std::vector<typename std::common_type<TYPE...>::type> toVector( const TYPE&... o )
    { return { o... }; }
    // ========================================================================
    
    // ========================================================================
    template <typename... TYPE> 
    std::string toString( const TYPE&... o )
    { return toString( toVector( o... ) ) ; }
    // ========================================================================
    
  } // end of namespace Utils 
} // end of namespace Gaudi 

// ============================================================================
// The END 
// ============================================================================
#endif // TOVECTOR_H
// ============================================================================
