// Class: ReadMLPMatching
// Automatically generated by MethodBase::MakeClass
//

/* configuration options =====================================================

#GEN -*-*-*-*-*-*-*-*-*-*-*- general info -*-*-*-*-*-*-*-*-*-*-*-

Method         : MLP::MLPMatching
TMVA Release   : 4.2.1         [262657]
ROOT Release   : 6.08/02       [395266]
Creator        : sesen
Date           : Wed Feb 22 12:42:39 2017
Host           : Linux lcgapp-slc6-x86-64-8.cern.ch 2.6.32-573.12.1.el6.x86_64 #1 SMP Wed Dec 16 21:43:04 CET 2015 x86_64 x86_64 x86_64 GNU/Linux
Dir            : /afs/cern.ch/work/s/sesen/Tracking/TMVA
Training events: 40000
Analysis type  : [Classification]


#OPT -*-*-*-*-*-*-*-*-*-*-*-*- options -*-*-*-*-*-*-*-*-*-*-*-*-

# Set by User:
NCycles: "700" [Number of training cycles]
HiddenLayers: "N+2,N" [Specification of hidden layer architecture]
NeuronType: "ReLU" [Neuron activation function type]
EstimatorType: "CE" [MSE (Mean Square Estimator) for Gaussian Likelihood or CE(Cross-Entropy) for Bernoulli Likelihood]
V: "False" [Verbose output (short form of "VerbosityLevel" below - overrides the latter one)]
VarTransform: "N" [List of variable transformations performed before training, e.g., "D_Background,P_Signal,G,N_AllClasses" for: "Decorrelation, PCA-transformation, Gaussianisation, Normalisation, each for the given class of events ('AllClasses' denotes all events of all classes, if no class indication is given, 'All' is assumed)"]
H: "True" [Print method-specific help message]
TestRate: "5" [Test for overtraining performed at each #th epochs]
UseRegulator: "False" [Use regulator to avoid over-training]
# Default:
RandomSeed: "1" [Random seed for initial synapse weights (0 means unique seed for each run; default value '1')]
NeuronInputType: "sum" [Neuron input function type]
VerbosityLevel: "Default" [Verbosity level]
CreateMVAPdfs: "False" [Create PDFs for classifier outputs (signal and background)]
IgnoreNegWeightsInTraining: "False" [Events with negative weights are ignored in the training (but are included for testing and performance evaluation)]
TrainingMethod: "BP" [Train with Back-Propagation (BP), BFGS Algorithm (BFGS), or Genetic Algorithm (GA - slower and worse)]
LearningRate: "2.000000e-02" [ANN learning rate parameter]
DecayRate: "1.000000e-02" [Decay rate for learning parameter]
EpochMonitoring: "False" [Provide epoch-wise monitoring plots according to TestRate (caution: causes big ROOT output file!)]
Sampling: "1.000000e+00" [Only 'Sampling' (randomly selected) events are trained each epoch]
SamplingEpoch: "1.000000e+00" [Sampling is used for the first 'SamplingEpoch' epochs, afterwards, all events are taken for training]
SamplingImportance: "1.000000e+00" [ The sampling weights of events in epochs which successful (worse estimator than before) are multiplied with SamplingImportance, else they are divided.]
SamplingTraining: "True" [The training sample is sampled]
SamplingTesting: "False" [The testing sample is sampled]
ResetStep: "50" [How often BFGS should reset history]
Tau: "3.000000e+00" [LineSearch "size step"]
BPMode: "sequential" [Back-propagation learning mode: sequential or batch]
BatchSize: "-1" [Batch size: number of events/batch, only set if in Batch Mode, -1 for BatchSize=number_of_events]
ConvergenceImprove: "1.000000e-30" [Minimum improvement which counts as improvement (<0 means automatic convergence check is turned off)]
ConvergenceTests: "-1" [Number of steps (without improvement) required for convergence (<0 means automatic convergence check is turned off)]
UpdateLimit: "10000" [Maximum times of regulator update]
CalculateErrors: "False" [Calculates inverse Hessian matrix at the end of the training to be able to calculate the uncertainties of an MVA value]
WeightRange: "1.000000e+00" [Take the events for the estimator calculations from small deviations from the desired value to large deviations only over the weight range]
##


#VAR -*-*-*-*-*-*-*-*-*-*-*-* variables *-*-*-*-*-*-*-*-*-*-*-*-

NVar 6
var0                          var0                          var0                          var0                                                            'F'    [2.43227204919e-05,14.9982471466]
var1                          var1                          var1                          var1                                                            'F'    [4.48324362878e-06,0.197798147798]
var2                          var2                          var2                          var2                                                            'F'    [0.000457763671875,248.849914551]
var3                          var3                          var3                          var3                                                            'F'    [0.00048828125,308.880126953]
var4                          var4                          var4                          var4                                                            'F'    [0.00014280481264,1.28639137745]
var5                          var5                          var5                          var5                                                            'F'    [4.47034835815e-08,0.0995713472366]
NSpec 0


============================================================================ */

#include <vector>
#include <cmath>
#include <string>
#include <iostream>

#ifndef IClassifierReader__def
#define IClassifierReader__def

class IClassifierReader {

 public:

   // constructor
   IClassifierReader() : fStatusIsClean( true ) {}
   virtual ~IClassifierReader() {}

   // return classifier response
  virtual float GetMvaValue( const std::array<float,6>& inputValues ) const = 0;

   // returns classifier status
   bool IsStatusClean() const { return fStatusIsClean; }

 protected:

   bool fStatusIsClean;
};

#endif

class ReadMLPMatching : public IClassifierReader {

 public:

   // constructor
  ReadMLPMatching( std::array<std::string,6>& theInputVars ) 
      : IClassifierReader(),
        fClassName( "ReadMLPMatching" ),
        fNvars( 6 ),
        fIsNormalised( false )
   {      
      // the training input variables
      const char* inputVars[] = { "var0", "var1", "var2", "var3", "var4", "var5" };

      // sanity checks
      if (theInputVars.size() <= 0) {
         std::cout << "Problem in class \"" << fClassName << "\": empty input vector" << std::endl;
         fStatusIsClean = false;
      }

      if (theInputVars.size() != fNvars) {
         std::cout << "Problem in class \"" << fClassName << "\": mismatch in number of input values: "
                   << theInputVars.size() << " != " << fNvars << std::endl;
         fStatusIsClean = false;
      }

      // validate input variables
      for (size_t ivar = 0; ivar < theInputVars.size(); ivar++) {
         if (theInputVars[ivar] != inputVars[ivar]) {
            std::cout << "Problem in class \"" << fClassName << "\": mismatch in input variable names" << std::endl
                      << " for variable [" << ivar << "]: " << theInputVars[ivar].c_str() << " != " << inputVars[ivar] << std::endl;
            fStatusIsClean = false;
         }
      }

      // initialize min and max vectors (for normalisation)
      fVmin[0] = -1;
      fVmax[0] = 1;
      fVmin[1] = -1;
      fVmax[1] = 1;
      fVmin[2] = -1;
      fVmax[2] = 1;
      fVmin[3] = -1;
      fVmax[3] = 1;
      fVmin[4] = -1;
      fVmax[4] = 1;
      fVmin[5] = -1;
      fVmax[5] = 1;

      // initialize input variable types
      fType[0] = 'F';
      fType[1] = 'F';
      fType[2] = 'F';
      fType[3] = 'F';
      fType[4] = 'F';
      fType[5] = 'F';

      // initialize constants
      Initialize();

      // initialize transformation
      InitTransform();
   }

   // destructor
   virtual ~ReadMLPMatching() {
      Clear(); // method-specific
   }

   // the classifier response
   // "inputValues" is a vector of input values in the same order as the 
   // variables given to the constructor
  float GetMvaValue( const std::array<float,6>& inputValues ) const override;

 private:

   // method-specific destructor
   void Clear();

   // input variable transformation

   float fMin_1[3][6];
   float fMax_1[3][6];
   void InitTransform_1();
  void Transform_1( std::array<float,6> & iv, int sigOrBgd ) const;
   void InitTransform();
  void Transform( std::array<float,6> & iv, int sigOrBgd ) const;

   // common member variables
   const char* fClassName;

   const size_t fNvars;
   size_t GetNvar()           const { return fNvars; }
   char   GetType( int ivar ) const { return fType[ivar]; }

   // normalisation of input variables
   const bool fIsNormalised;
   bool IsNormalised() const { return fIsNormalised; }
   float fVmin[6];
   float fVmax[6];
   float NormVariable( float x, float xmin, float xmax ) const {
      // normalise to output range: [-1, 1]
      return 2*(x - xmin)/(xmax - xmin) - 1.0;
   }

   // type of input variable: 'F' or 'I'
   char   fType[6];

   // initialize internal variables
   void Initialize();
   float GetMvaValue__( const std::array<float,6>& inputValues ) const;

   // private members (method specific)

   float ActivationFnc(float x) const;
   float OutputActivationFnc(float x) const;

   int fLayers;
   int fLayerSize[4];
   float fWeightMatrix0to1[9][7];   // weight matrix from layer 0 to 1
   float fWeightMatrix1to2[7][9];   // weight matrix from layer 1 to 2
   float fWeightMatrix2to3[1][7];   // weight matrix from layer 2 to 3

   float * fWeights[4];
};

inline void ReadMLPMatching::Initialize()
{
   // build network structure
   fLayers = 4;
   fLayerSize[0] = 7; fWeights[0] = new float[7]; 
   fLayerSize[1] = 9; fWeights[1] = new float[9]; 
   fLayerSize[2] = 7; fWeights[2] = new float[7]; 
   fLayerSize[3] = 1; fWeights[3] = new float[1]; 
   // weight matrix from layer 0 to 1
   fWeightMatrix0to1[0][0] = -2.10467380768355;
   fWeightMatrix0to1[1][0] = 3.60915456969325;
   fWeightMatrix0to1[2][0] = 2.8450698760656;
   fWeightMatrix0to1[3][0] = 3.03009031225432;
   fWeightMatrix0to1[4][0] = -1.58601875808525;
   fWeightMatrix0to1[5][0] = -1.42009121925821;
   fWeightMatrix0to1[6][0] = -0.79066972900182;
   fWeightMatrix0to1[7][0] = 2.01666387308105;
   fWeightMatrix0to1[0][1] = 1.48487631068631;
   fWeightMatrix0to1[1][1] = -16.7549933764435;
   fWeightMatrix0to1[2][1] = -2.39661201056413;
   fWeightMatrix0to1[3][1] = -3.0254048205659;
   fWeightMatrix0to1[4][1] = 1.43567885018765;
   fWeightMatrix0to1[5][1] = 1.67209897071318;
   fWeightMatrix0to1[6][1] = -0.617757099680603;
   fWeightMatrix0to1[7][1] = 0.991244361014379;
   fWeightMatrix0to1[0][2] = -7.12746784349464;
   fWeightMatrix0to1[1][2] = 8.91452852206894;
   fWeightMatrix0to1[2][2] = 3.16678432018412;
   fWeightMatrix0to1[3][2] = 8.67799850626591;
   fWeightMatrix0to1[4][2] = 4.60711131236418;
   fWeightMatrix0to1[5][2] = 1.47414000381531;
   fWeightMatrix0to1[6][2] = 0.740878002718091;
   fWeightMatrix0to1[7][2] = -0.0119014648333567;
   fWeightMatrix0to1[0][3] = -5.04716494421408;
   fWeightMatrix0to1[1][3] = -5.71131693082401;
   fWeightMatrix0to1[2][3] = -3.65432869749546;
   fWeightMatrix0to1[3][3] = 6.76498749055009;
   fWeightMatrix0to1[4][3] = -2.33818722755118;
   fWeightMatrix0to1[5][3] = -1.88252792532098;
   fWeightMatrix0to1[6][3] = 0.681870030239224;
   fWeightMatrix0to1[7][3] = 1.76014613568861;
   fWeightMatrix0to1[0][4] = 0.937053929213923;
   fWeightMatrix0to1[1][4] = 0.737326089352988;
   fWeightMatrix0to1[2][4] = 1.7489076894551;
   fWeightMatrix0to1[3][4] = -3.94212546690416;
   fWeightMatrix0to1[4][4] = -4.77875990172267;
   fWeightMatrix0to1[5][4] = 4.81274735719001;
   fWeightMatrix0to1[6][4] = -1.20759406685829;
   fWeightMatrix0to1[7][4] = 1.75752340955755;
   fWeightMatrix0to1[0][5] = 8.76578873896846;
   fWeightMatrix0to1[1][5] = 1.99256964323911;
   fWeightMatrix0to1[2][5] = 2.15354511859953;
   fWeightMatrix0to1[3][5] = -5.58198313649052;
   fWeightMatrix0to1[4][5] = -4.61194219611968;
   fWeightMatrix0to1[5][5] = 1.0343666296399;
   fWeightMatrix0to1[6][5] = 0.769290467724204;
   fWeightMatrix0to1[7][5] = 0.844081475731841;
   fWeightMatrix0to1[0][6] = -1.60124676515763;
   fWeightMatrix0to1[1][6] = -6.54224331779727;
   fWeightMatrix0to1[2][6] = 1.0731556843342;
   fWeightMatrix0to1[3][6] = 6.13121465569836;
   fWeightMatrix0to1[4][6] = -5.1474030708851;
   fWeightMatrix0to1[5][6] = 3.30321224203562;
   fWeightMatrix0to1[6][6] = -1.8437808630988;
   fWeightMatrix0to1[7][6] = -0.867511396397175;
   // weight matrix from layer 1 to 2
   fWeightMatrix1to2[0][0] = -0.335842488368464;
   fWeightMatrix1to2[1][0] = -2.6322358519105;
   fWeightMatrix1to2[2][0] = 2.52381813107018;
   fWeightMatrix1to2[3][0] = 0.107300986322878;
   fWeightMatrix1to2[4][0] = -2.68203006425824;
   fWeightMatrix1to2[5][0] = 0.495624057735357;
   fWeightMatrix1to2[0][1] = 1.31510416948451;
   fWeightMatrix1to2[1][1] = -0.620046336936052;
   fWeightMatrix1to2[2][1] = 2.41970640987554;
   fWeightMatrix1to2[3][1] = -0.356536553661283;
   fWeightMatrix1to2[4][1] = -1.04722537942796;
   fWeightMatrix1to2[5][1] = -1.17838191930942;
   fWeightMatrix1to2[0][2] = -1.08339202554144;
   fWeightMatrix1to2[1][2] = -0.966137203389831;
   fWeightMatrix1to2[2][2] = -2.58971499535518;
   fWeightMatrix1to2[3][2] = -1.44215015967071;
   fWeightMatrix1to2[4][2] = 0.592537400052767;
   fWeightMatrix1to2[5][2] = -1.36921389022631;
   fWeightMatrix1to2[0][3] = 0.211413608048063;
   fWeightMatrix1to2[1][3] = -1.01742380872799;
   fWeightMatrix1to2[2][3] = -0.968834927183935;
   fWeightMatrix1to2[3][3] = -1.86331475991756;
   fWeightMatrix1to2[4][3] = 0.443035042490385;
   fWeightMatrix1to2[5][3] = -3.63626611600421;
   fWeightMatrix1to2[0][4] = 0.744538425755597;
   fWeightMatrix1to2[1][4] = 0.439866892627181;
   fWeightMatrix1to2[2][4] = 0.596380686421857;
   fWeightMatrix1to2[3][4] = -0.814997842816678;
   fWeightMatrix1to2[4][4] = 1.04250502861251;
   fWeightMatrix1to2[5][4] = 1.33328678593093;
   fWeightMatrix1to2[0][5] = 0.506172742257546;
   fWeightMatrix1to2[1][5] = -0.814028236207492;
   fWeightMatrix1to2[2][5] = -2.92436653062039;
   fWeightMatrix1to2[3][5] = -1.71082039039031;
   fWeightMatrix1to2[4][5] = 0.0366507403191981;
   fWeightMatrix1to2[5][5] = -0.768942130953941;
   fWeightMatrix1to2[0][6] = 1.63438201788813;
   fWeightMatrix1to2[1][6] = -1.61531096417457;
   fWeightMatrix1to2[2][6] = -0.825543426908553;
   fWeightMatrix1to2[3][6] = 1.61348068527877;
   fWeightMatrix1to2[4][6] = -0.848898627795279;
   fWeightMatrix1to2[5][6] = -1.52203810494393;
   fWeightMatrix1to2[0][7] = -1.60491458139638;
   fWeightMatrix1to2[1][7] = 0.0967622129188889;
   fWeightMatrix1to2[2][7] = -1.97120176537683;
   fWeightMatrix1to2[3][7] = -1.66550797875971;
   fWeightMatrix1to2[4][7] = -1.75383088887409;
   fWeightMatrix1to2[5][7] = 1.73197121411447;
   fWeightMatrix1to2[0][8] = -1.67441323067471;
   fWeightMatrix1to2[1][8] = 2.1738127136118;
   fWeightMatrix1to2[2][8] = -6.01050777438154;
   fWeightMatrix1to2[3][8] = -0.950888486660694;
   fWeightMatrix1to2[4][8] = 2.86712899136636;
   fWeightMatrix1to2[5][8] = 1.44945462508369;
   // weight matrix from layer 2 to 3
   fWeightMatrix2to3[0][0] = -0.679191540548942;
   fWeightMatrix2to3[0][1] = 2.23245114571419;
   fWeightMatrix2to3[0][2] = -0.776964333329809;
   fWeightMatrix2to3[0][3] = 0.251851033948731;
   fWeightMatrix2to3[0][4] = -0.770088049724076;
   fWeightMatrix2to3[0][5] = 0.844485645134552;
   fWeightMatrix2to3[0][6] = 1.40317990187682;
}

inline float ReadMLPMatching::GetMvaValue__( const std::array<float,6>& inputValues ) const
{
   if (inputValues.size() != (unsigned int)fLayerSize[0]-1) {
      std::cout << "Input vector needs to be of size " << fLayerSize[0]-1 << std::endl;
      return 0;
   }

   for (int l=0; l<fLayers; l++)
      for (int i=0; i<fLayerSize[l]; i++) fWeights[l][i]=0;

   for (int l=0; l<fLayers-1; l++)
      fWeights[l][fLayerSize[l]-1]=1;

   for (int i=0; i<fLayerSize[0]-1; i++)
      fWeights[0][i]=inputValues[i];

   // layer 0 to 1
   for (int o=0; o<fLayerSize[1]-1; o++) {
      for (int i=0; i<fLayerSize[0]; i++) {
         float inputVal = fWeightMatrix0to1[o][i] * fWeights[0][i];
         fWeights[1][o] += inputVal;
      }
      fWeights[1][o] = ActivationFnc(fWeights[1][o]);
   }
   // layer 1 to 2
   for (int o=0; o<fLayerSize[2]-1; o++) {
      for (int i=0; i<fLayerSize[1]; i++) {
         float inputVal = fWeightMatrix1to2[o][i] * fWeights[1][i];
         fWeights[2][o] += inputVal;
      }
      fWeights[2][o] = ActivationFnc(fWeights[2][o]);
   }
   // layer 2 to 3
   for (int o=0; o<fLayerSize[3]; o++) {
      for (int i=0; i<fLayerSize[2]; i++) {
         float inputVal = fWeightMatrix2to3[o][i] * fWeights[2][i];
         fWeights[3][o] += inputVal;
      }
      fWeights[3][o] = OutputActivationFnc(fWeights[3][o]);
   }

   return fWeights[3][0];
}

float ReadMLPMatching::ActivationFnc(float x) const {
   // rectified linear unit
   return x>0 ? x : 0; 
}
float ReadMLPMatching::OutputActivationFnc(float x) const {
   // sigmoid
   return 1.0/(1.0+exp(-x));
}
   
// Clean up
inline void ReadMLPMatching::Clear() 
{
   // clean up the arrays
   for (int lIdx = 0; lIdx < 4; lIdx++) {
      delete[] fWeights[lIdx];
   }
}
inline float ReadMLPMatching::GetMvaValue( const std::array<float,6>& inputValues ) const
{
  // classifier response value
  float retval = 0;
  
      // classifier response, sanity check first
  if (!IsStatusClean()) {
    std::cout << "Problem in class \"" << fClassName << "\": cannot return classifier response"
	      << " because status is dirty" << std::endl;
    retval = 0;
      }
  else {
    if (IsNormalised()) {
      // normalise variables
	  std::array<float,6> iV;
	  for (int i=0;i<6;i++){
	    iV[i]=NormVariable( inputValues[i], fVmin[i], fVmax[i] );
	  }
	  Transform( iV, -1 );
	  retval = GetMvaValue__( iV );
    }
    else {
	  std::array<float,6> iV= inputValues;
	  Transform( iV, -1 );
	  retval = GetMvaValue__( iV );
    }
  }
  
  return retval;
}

//_______________________________________________________________________
inline void ReadMLPMatching::InitTransform_1()
{
   // Normalization transformation, initialisation
   fMin_1[0][0] = 2.43227204919e-05;
   fMax_1[0][0] = 14.9539842606;
   fMin_1[1][0] = 0.00236654723994;
   fMax_1[1][0] = 14.9982471466;
   fMin_1[2][0] = 2.43227204919e-05;
   fMax_1[2][0] = 14.9982471466;
   fMin_1[0][1] = 4.1903447709e-05;
   fMax_1[0][1] = 0.197798147798;
   fMin_1[1][1] = 4.48324362878e-06;
   fMax_1[1][1] = 0.190361052752;
   fMin_1[2][1] = 4.48324362878e-06;
   fMax_1[2][1] = 0.197798147798;
   fMin_1[0][2] = 0.000457763671875;
   fMax_1[0][2] = 197.26550293;
   fMin_1[1][2] = 0.000990867614746;
   fMax_1[1][2] = 248.849914551;
   fMin_1[2][2] = 0.000457763671875;
   fMax_1[2][2] = 248.849914551;
   fMin_1[0][3] = 0.000640869140625;
   fMax_1[0][3] = 229.589660645;
   fMin_1[1][3] = 0.00048828125;
   fMax_1[1][3] = 308.880126953;
   fMin_1[2][3] = 0.00048828125;
   fMax_1[2][3] = 308.880126953;
   fMin_1[0][4] = 0.00344682112336;
   fMax_1[0][4] = 1.28639137745;
   fMin_1[1][4] = 0.00014280481264;
   fMax_1[1][4] = 1.2539345026;
   fMin_1[2][4] = 0.00014280481264;
   fMax_1[2][4] = 1.28639137745;
   fMin_1[0][5] = 4.47034835815e-08;
   fMax_1[0][5] = 0.0929135233164;
   fMin_1[1][5] = 3.53902578354e-07;
   fMax_1[1][5] = 0.0995713472366;
   fMin_1[2][5] = 4.47034835815e-08;
   fMax_1[2][5] = 0.0995713472366;
}

//_______________________________________________________________________
inline void ReadMLPMatching::Transform_1( std::array<float,6>& iv, int cls) const
{
   // Normalization transformation
   if (cls < 0 || cls > 2)  cls = 2;
 
   for (int ivar=0;ivar<6;ivar++) {
      float offset = fMin_1[cls][ivar];
      float scale  = 1.0/(fMax_1[cls][ivar]-fMin_1[cls][ivar]);
      iv[ivar] = (iv[ivar]-offset)*scale * 2 - 1;
   }
}

//_______________________________________________________________________
inline void ReadMLPMatching::InitTransform()
{
   InitTransform_1();
}

//_______________________________________________________________________
inline void ReadMLPMatching::Transform( std::array<float,6>& iv, int sigOrBgd ) const
{
   Transform_1( iv, sigOrBgd );
}
