// Class: ReadASFDeep
// Automatically generated by MethodBase::MakeClass
//

/* configuration options =====================================================

#GEN -*-*-*-*-*-*-*-*-*-*-*- general info -*-*-*-*-*-*-*-*-*-*-*-

Method         : MLP::ASFDeep
TMVA Release   : 4.2.1         [262657]
ROOT Release   : 6.04/14       [394254]
Creator        : mstahl
Date           : Mon Mar  7 09:31:23 2016
Host           : Linux kreplinpc 3.13.0-77-generic #121-Ubuntu SMP Wed Jan 20 10:50:42 UTC 2016 x86_64 x86_64 x86_64 GNU/Linux
Dir            : /work/MVATests
Training events: 50000
Analysis type  : [Classification]


#OPT -*-*-*-*-*-*-*-*-*-*-*-*- options -*-*-*-*-*-*-*-*-*-*-*-*-

# Set by User:
HiddenLayers: "17,9,5" [Specification of hidden layer architecture]
NeuronType: "ReLU" [Neuron activation function type]
RandomSeed: "0" [Random seed for initial synapse weights (0 means unique seed for each run; default value '1')]
EstimatorType: "CE" [MSE (Mean Square Estimator) for Gaussian Likelihood or CE(Cross-Entropy) for Bernoulli Likelihood]
VarTransform: "N" [List of variable transformations performed before training, e.g., "D_Background,P_Signal,G,N_AllClasses" for: "Decorrelation, PCA-transformation, Gaussianisation, Normalisation, each for the given class of events ('AllClasses' denotes all events of all classes, if no class indication is given, 'All' is assumed)"]
CreateMVAPdfs: "True" [Create PDFs for classifier outputs (signal and background)]
TestRate: "3" [Test for overtraining performed at each #th epochs]
# Default:
NCycles: "500" [Number of training cycles]
NeuronInputType: "sum" [Neuron input function type]
V: "False" [Verbose output (short form of "VerbosityLevel" below - overrides the latter one)]
VerbosityLevel: "Default" [Verbosity level]
H: "False" [Print method-specific help message]
IgnoreNegWeightsInTraining: "False" [Events with negative weights are ignored in the training (but are included for testing and performance evaluation)]
TrainingMethod: "BP" [Train with Back-Propagation (BP), BFGS Algorithm (BFGS), or Genetic Algorithm (GA - slower and worse)]
LearningRate: "2.000000e-02" [ANN learning rate parameter]
DecayRate: "1.000000e-02" [Decay rate for learning parameter]
EpochMonitoring: "False" [Provide epoch-wise monitoring plots according to TestRate (caution: causes big ROOT output file!)]
Sampling: "1.000000e+00" [Only 'Sampling' (randomly selected) events are trained each epoch]
SamplingEpoch: "1.000000e+00" [Sampling is used for the first 'SamplingEpoch' epochs, afterwards, all events are taken for training]
SamplingImportance: "1.000000e+00" [ The sampling weights of events in epochs which successful (worse estimator than before) are multiplied with SamplingImportance, else they are divided.]
SamplingTraining: "True" [The training sample is sampled]
SamplingTesting: "False" [The testing sample is sampled]
ResetStep: "50" [How often BFGS should reset history]
Tau: "3.000000e+00" [LineSearch "size step"]
BPMode: "sequential" [Back-propagation learning mode: sequential or batch]
BatchSize: "-1" [Batch size: number of events/batch, only set if in Batch Mode, -1 for BatchSize=number_of_events]
ConvergenceImprove: "1.000000e-30" [Minimum improvement which counts as improvement (<0 means automatic convergence check is turned off)]
ConvergenceTests: "-1" [Number of steps (without improvement) required for convergence (<0 means automatic convergence check is turned off)]
UseRegulator: "False" [Use regulator to avoid over-training]
UpdateLimit: "10000" [Maximum times of regulator update]
CalculateErrors: "False" [Calculates inverse Hessian matrix at the end of the training to be able to calculate the uncertainties of an MVA value]
WeightRange: "1.000000e+00" [Take the events for the estimator calculations from small deviations from the desired value to large deviations only over the weight range]
##


#VAR -*-*-*-*-*-*-*-*-*-*-*-* variables *-*-*-*-*-*-*-*-*-*-*-*-

NVar 16
mdx                           mdx                           mdx                           <#Delta x>                    mm                                'F'    [0.0129130277783,22.3806743622]
sx                            sx                            sx                            #sigma_{Cluster}              mm                                'F'    [0.0221927668899,33.4279251099]
spread                        spread                        spread                        x_{last} - x_{first}          mm                                'F'    [0.0645651370287,89.5226974487]
nwHits                        nwHits                        nwHits                        # of weighted hits                                              'I'    [7,45]
mx                            mx                            mx                            <x_{Cluster}>                 mm                                'F'    [-2777.8125,2794.3125]
nPlanes                       nPlanes                       nPlanes                       # of planes                                                     'I'    [5,12]
tx                            tx                            tx                            XSlope                                                          'F'    [-0.436507284641,0.504935562611]
ty                            ty                            ty                            YSlope                                                          'F'    [-0.278397083282,0.277494072914]
log(PT)                       log_PT_                       log(PT)                       ln(p_{T})                     ln(GeV)                           'F'    [-2.53470730782,6.00070905685]
log(chi2)                     log_chi2_                     log(chi2)                     ln(#chi^{2})                                                    'F'    [-2.86267995834,7.60771226883]
log(P)                        log_P_                        log(P)                        ln(p)                         ln(GeV)                           'F'    [0.000701896322425,9.39501285553]
Bx                            Bx                            Bx                            B_{x}                                                           'F'    [-1.20764863491,1.30925452709]
dt                            dt                            dt                            #Delta_{slope}                                                  'F'    [-1.49837112427,1.47500002384]
xRef                          xRef                          xRef                          x(z_{Ref}})                                                     'F'    [-18131.1601562,14743.1650391]
nYPlanes                      nYPlanes                      nYPlanes                      # of stereo planes                                              'I'    [2,6]
sdy                           sdy                           sdy                           #frac{#Delta y}{y_{tol}}                                        'F'    [1.8642298528e-05,2.68636751175]
NSpec 0


============================================================================ */

#include <vector>
#include <cmath>
#include <string>
#include <iostream>

#ifndef IClassifierReader__def
#define IClassifierReader__def

class IClassifierReader {

public:

  // constructor
  IClassifierReader() : fStatusIsClean( true ) {}
  virtual ~IClassifierReader() {}

  // return classifier response
  virtual double GetMvaValue( std::vector<double>& inputValues ) const = 0;

  // returns classifier status
  bool IsStatusClean() const { return fStatusIsClean; }

protected:

  bool fStatusIsClean;
};

#endif

class ReadASFDeep : public IClassifierReader {

public:

  // constructor
  ReadASFDeep( std::vector<std::string>& theInputVars )
    : IClassifierReader(),
      fClassName( "ReadASFDeep" ),
      fNvars( 16 ),
      fIsNormalised( false )
  {
    // the training input variables
    const char* inputVars[] = { "mdx", "sx", "spread", "nwHits", "mx", "nPlanes", "tx", "ty", "log(PT)", "log(chi2)", "log(P)", "Bx", "dt", "xRef", "nYPlanes", "sdy" };

    // sanity checks
    if (theInputVars.size() <= 0) {
      std::cout << "Problem in class \"" << fClassName << "\": empty input vector" << std::endl;
      fStatusIsClean = false;
    }

    if (theInputVars.size() != fNvars) {
      std::cout << "Problem in class \"" << fClassName << "\": mismatch in number of input values: "
                << theInputVars.size() << " != " << fNvars << std::endl;
      fStatusIsClean = false;
    }

    // validate input variables
    for (size_t ivar = 0; ivar < theInputVars.size(); ivar++) {
      if (theInputVars[ivar] != inputVars[ivar]) {
        std::cout << "Problem in class \"" << fClassName << "\": mismatch in input variable names" << std::endl
                  << " for variable [" << ivar << "]: " << theInputVars[ivar].c_str() << " != " << inputVars[ivar] << std::endl;
        fStatusIsClean = false;
      }
    }

    // initialize min and max vectors (for normalisation)
    fVmin[0] = -1;
    fVmax[0] = 1;
    fVmin[1] = -1;
    fVmax[1] = 1;
    fVmin[2] = -1;
    fVmax[2] = 0.99999988079071;
    fVmin[3] = -1;
    fVmax[3] = 1;
    fVmin[4] = -1;
    fVmax[4] = 0.99999988079071;
    fVmin[5] = -1;
    fVmax[5] = 1;
    fVmin[6] = -1;
    fVmax[6] = 1;
    fVmin[7] = -1;
    fVmax[7] = 1;
    fVmin[8] = -1;
    fVmax[8] = 1;
    fVmin[9] = -1;
    fVmax[9] = 1;
    fVmin[10] = -1;
    fVmax[10] = 1;
    fVmin[11] = -1;
    fVmax[11] = 1;
    fVmin[12] = -1;
    fVmax[12] = 1;
    fVmin[13] = -1;
    fVmax[13] = 1;
    fVmin[14] = -1;
    fVmax[14] = 1;
    fVmin[15] = -1;
    fVmax[15] = 1;

    // initialize input variable types
    fType[0] = 'F';
    fType[1] = 'F';
    fType[2] = 'F';
    fType[3] = 'I';
    fType[4] = 'F';
    fType[5] = 'I';
    fType[6] = 'F';
    fType[7] = 'F';
    fType[8] = 'F';
    fType[9] = 'F';
    fType[10] = 'F';
    fType[11] = 'F';
    fType[12] = 'F';
    fType[13] = 'F';
    fType[14] = 'I';
    fType[15] = 'F';

    // initialize constants
    Initialize();

    // initialize transformation
    InitTransform();
  }

  // destructor
  virtual ~ReadASFDeep() {
    Clear(); // method-specific
  }

  // the classifier response
  // "inputValues" is a vector of input values in the same order as the
  // variables given to the constructor
  double GetMvaValue( std::vector<double>& inputValues ) const override;

private:

  // method-specific destructor
  void Clear();

  // input variable transformation

  double fMin_1[3][16];
  double fMax_1[3][16];
  void InitTransform_1();
  void Transform_1( std::vector<double> & iv, int sigOrBgd ) const;
  void InitTransform();
  void Transform( std::vector<double> & iv, int sigOrBgd ) const;

  // common member variables
  const char* fClassName;

  const size_t fNvars;
  size_t GetNvar()           const { return fNvars; }
  char   GetType( int ivar ) const { return fType[ivar]; }

  // normalisation of input variables
  const bool fIsNormalised;
  bool IsNormalised() const { return fIsNormalised; }
  double fVmin[16];
  double fVmax[16];
  double NormVariable( double x, double xmin, double xmax ) const {
    // normalise to output range: [-1, 1]
    return 2*(x - xmin)/(xmax - xmin) - 1.0;
  }

  // type of input variable: 'F' or 'I'
  char   fType[16];

  // initialize internal variables
  void Initialize();
  double GetMvaValue__( const std::vector<double>& inputValues ) const;

  // private members (method specific)

  double ActivationFnc(double x) const;
  double OutputActivationFnc(double x) const;

  int fLayers;
  int fLayerSize[5];
  double fWeightMatrix0to1[18][17];   // weight matrix from layer 0 to 1
  double fWeightMatrix1to2[10][18];   // weight matrix from layer 1 to 2
  double fWeightMatrix2to3[6][10];   // weight matrix from layer 2 to 3
  double fWeightMatrix3to4[1][6];   // weight matrix from layer 3 to 4

  double * fWeights[5];
};

inline void ReadASFDeep::Initialize()
{
  // build network structure
  fLayers = 5;
  fLayerSize[0] = 17; fWeights[0] = new double[17];
  fLayerSize[1] = 18; fWeights[1] = new double[18];
  fLayerSize[2] = 10; fWeights[2] = new double[10];
  fLayerSize[3] = 6; fWeights[3] = new double[6];
  fLayerSize[4] = 1; fWeights[4] = new double[1];
  // weight matrix from layer 0 to 1
  fWeightMatrix0to1[0][0] = -3.60150606222802;
  fWeightMatrix0to1[1][0] = 0.196557936902239;
  fWeightMatrix0to1[2][0] = -2.14275092535896;
  fWeightMatrix0to1[3][0] = 0.449584514480786;
  fWeightMatrix0to1[4][0] = 1.98117743605103;
  fWeightMatrix0to1[5][0] = 1.41648077117304;
  fWeightMatrix0to1[6][0] = 0.170799243140328;
  fWeightMatrix0to1[7][0] = -1.72418530319372;
  fWeightMatrix0to1[8][0] = 2.45890334839684;
  fWeightMatrix0to1[9][0] = -3.08523441485008;
  fWeightMatrix0to1[10][0] = 1.1485299508632;
  fWeightMatrix0to1[11][0] = 0.428267384511668;
  fWeightMatrix0to1[12][0] = -2.57727423456604;
  fWeightMatrix0to1[13][0] = 1.2193911972431;
  fWeightMatrix0to1[14][0] = 0.8687588871426;
  fWeightMatrix0to1[15][0] = -0.106269364240382;
  fWeightMatrix0to1[16][0] = 5.59875217982487;
  fWeightMatrix0to1[0][1] = 4.41935522357394;
  fWeightMatrix0to1[1][1] = -0.447946179107122;
  fWeightMatrix0to1[2][1] = 0.103406590629525;
  fWeightMatrix0to1[3][1] = -3.04635575467099;
  fWeightMatrix0to1[4][1] = 1.26110853447088;
  fWeightMatrix0to1[5][1] = 2.15837500876054;
  fWeightMatrix0to1[6][1] = 1.74193286132875;
  fWeightMatrix0to1[7][1] = 0.714799942775567;
  fWeightMatrix0to1[8][1] = -3.7753400520125;
  fWeightMatrix0to1[9][1] = 6.97475259040663;
  fWeightMatrix0to1[10][1] = 1.87709431101671;
  fWeightMatrix0to1[11][1] = -1.04142954921243;
  fWeightMatrix0to1[12][1] = 2.79168643604173;
  fWeightMatrix0to1[13][1] = 1.77432504594785;
  fWeightMatrix0to1[14][1] = 1.61468845688604;
  fWeightMatrix0to1[15][1] = 1.42073813218332;
  fWeightMatrix0to1[16][1] = -13.2782144453314;
  fWeightMatrix0to1[0][2] = 1.66926027969059;
  fWeightMatrix0to1[1][2] = 0.786725719460664;
  fWeightMatrix0to1[2][2] = 3.10683303372547;
  fWeightMatrix0to1[3][2] = -1.26378341568433;
  fWeightMatrix0to1[4][2] = 0.705942974845479;
  fWeightMatrix0to1[5][2] = -1.86911323097004;
  fWeightMatrix0to1[6][2] = 1.03596055181343;
  fWeightMatrix0to1[7][2] = 3.76898006212794;
  fWeightMatrix0to1[8][2] = -1.44641021972603;
  fWeightMatrix0to1[9][2] = -1.75692326410553;
  fWeightMatrix0to1[10][2] = -1.32833921066833;
  fWeightMatrix0to1[11][2] = -0.44246623699215;
  fWeightMatrix0to1[12][2] = -1.21727735886121;
  fWeightMatrix0to1[13][2] = 2.02466895953534;
  fWeightMatrix0to1[14][2] = 1.89499809878198;
  fWeightMatrix0to1[15][2] = 1.84308406023131;
  fWeightMatrix0to1[16][2] = -5.48983596657727;
  fWeightMatrix0to1[0][3] = -8.51582474101208;
  fWeightMatrix0to1[1][3] = -2.34081158449562;
  fWeightMatrix0to1[2][3] = -0.10449831149895;
  fWeightMatrix0to1[3][3] = 0.433520820390286;
  fWeightMatrix0to1[4][3] = 1.43141149249258;
  fWeightMatrix0to1[5][3] = 0.616710588750351;
  fWeightMatrix0to1[6][3] = 0.644104727487436;
  fWeightMatrix0to1[7][3] = 2.74192186610715;
  fWeightMatrix0to1[8][3] = 0.696191799996262;
  fWeightMatrix0to1[9][3] = 1.0211501891872;
  fWeightMatrix0to1[10][3] = -5.94074162665012;
  fWeightMatrix0to1[11][3] = 1.32903703688531;
  fWeightMatrix0to1[12][3] = -0.429482937927752;
  fWeightMatrix0to1[13][3] = 0.374283310083796;
  fWeightMatrix0to1[14][3] = 2.01141480240562;
  fWeightMatrix0to1[15][3] = -0.587012603611736;
  fWeightMatrix0to1[16][3] = 0.187610690143959;
  fWeightMatrix0to1[0][4] = -0.584462068992792;
  fWeightMatrix0to1[1][4] = 0.951811969246592;
  fWeightMatrix0to1[2][4] = -0.887254852808764;
  fWeightMatrix0to1[3][4] = 2.78166307672748;
  fWeightMatrix0to1[4][4] = 0.502792759734874;
  fWeightMatrix0to1[5][4] = -0.999989561700239;
  fWeightMatrix0to1[6][4] = 0.89426894156506;
  fWeightMatrix0to1[7][4] = -0.892246626102138;
  fWeightMatrix0to1[8][4] = -1.59711704083011;
  fWeightMatrix0to1[9][4] = -0.657584870340403;
  fWeightMatrix0to1[10][4] = -1.40257205994735;
  fWeightMatrix0to1[11][4] = 0.428874272189178;
  fWeightMatrix0to1[12][4] = -0.673230109347528;
  fWeightMatrix0to1[13][4] = -0.988078067446397;
  fWeightMatrix0to1[14][4] = -0.330812058733862;
  fWeightMatrix0to1[15][4] = 0.927940354595753;
  fWeightMatrix0to1[16][4] = -0.94678652090537;
  fWeightMatrix0to1[0][5] = 0.778695230659957;
  fWeightMatrix0to1[1][5] = -0.759800778923178;
  fWeightMatrix0to1[2][5] = 1.94418553618381;
  fWeightMatrix0to1[3][5] = -1.55191632712796;
  fWeightMatrix0to1[4][5] = 0.218817967579787;
  fWeightMatrix0to1[5][5] = 1.42340730098413;
  fWeightMatrix0to1[6][5] = 0.408980944734372;
  fWeightMatrix0to1[7][5] = 1.68339131570822;
  fWeightMatrix0to1[8][5] = -0.630070461666536;
  fWeightMatrix0to1[9][5] = 0.274590973380546;
  fWeightMatrix0to1[10][5] = 0.011157293486887;
  fWeightMatrix0to1[11][5] = -0.933838704657909;
  fWeightMatrix0to1[12][5] = 0.405282274180458;
  fWeightMatrix0to1[13][5] = 0.999297890750045;
  fWeightMatrix0to1[14][5] = -0.464971282979564;
  fWeightMatrix0to1[15][5] = -0.72545147428539;
  fWeightMatrix0to1[16][5] = 2.76054374350603;
  fWeightMatrix0to1[0][6] = 2.27734613225297;
  fWeightMatrix0to1[1][6] = -5.46583899525603;
  fWeightMatrix0to1[2][6] = -1.74211728116674;
  fWeightMatrix0to1[3][6] = 6.07532093803674;
  fWeightMatrix0to1[4][6] = 1.89393982934456;
  fWeightMatrix0to1[5][6] = 0.316126638186507;
  fWeightMatrix0to1[6][6] = -0.198232875183457;
  fWeightMatrix0to1[7][6] = -0.192227033004879;
  fWeightMatrix0to1[8][6] = -6.95345092978942;
  fWeightMatrix0to1[9][6] = 0.505977353156497;
  fWeightMatrix0to1[10][6] = -0.109481199704546;
  fWeightMatrix0to1[11][6] = 1.93950125441732;
  fWeightMatrix0to1[12][6] = 0.3469547089956;
  fWeightMatrix0to1[13][6] = -1.39542839824921;
  fWeightMatrix0to1[14][6] = -0.46600377088254;
  fWeightMatrix0to1[15][6] = 1.96014585721419;
  fWeightMatrix0to1[16][6] = -0.816070108757338;
  fWeightMatrix0to1[0][7] = -0.152308859055696;
  fWeightMatrix0to1[1][7] = -0.628838795621355;
  fWeightMatrix0to1[2][7] = 0.378046482614072;
  fWeightMatrix0to1[3][7] = -0.34935991612521;
  fWeightMatrix0to1[4][7] = 1.29479242811051;
  fWeightMatrix0to1[5][7] = 0.505840756521701;
  fWeightMatrix0to1[6][7] = -1.97146129450858;
  fWeightMatrix0to1[7][7] = -0.0816808241535986;
  fWeightMatrix0to1[8][7] = -0.777988367060469;
  fWeightMatrix0to1[9][7] = 0.218624946468243;
  fWeightMatrix0to1[10][7] = -0.0426413741639372;
  fWeightMatrix0to1[11][7] = -1.48106924607003;
  fWeightMatrix0to1[12][7] = -0.308828174275149;
  fWeightMatrix0to1[13][7] = -0.0317271341326757;
  fWeightMatrix0to1[14][7] = -0.714674580592711;
  fWeightMatrix0to1[15][7] = 1.0328409686695;
  fWeightMatrix0to1[16][7] = 0.305569770658362;
  fWeightMatrix0to1[0][8] = 3.86916420330753;
  fWeightMatrix0to1[1][8] = -0.694739081996566;
  fWeightMatrix0to1[2][8] = 3.48038987264253;
  fWeightMatrix0to1[3][8] = 1.42707229831144;
  fWeightMatrix0to1[4][8] = 1.48472719951442;
  fWeightMatrix0to1[5][8] = -7.79941097574151;
  fWeightMatrix0to1[6][8] = 2.11385056346559;
  fWeightMatrix0to1[7][8] = 0.0171367147787619;
  fWeightMatrix0to1[8][8] = -0.0860505147709525;
  fWeightMatrix0to1[9][8] = -6.04978850012733;
  fWeightMatrix0to1[10][8] = -6.63764749132802;
  fWeightMatrix0to1[11][8] = 0.743022244447969;
  fWeightMatrix0to1[12][8] = 1.08376007193949;
  fWeightMatrix0to1[13][8] = 1.91044098592041;
  fWeightMatrix0to1[14][8] = 1.0019403494916;
  fWeightMatrix0to1[15][8] = -1.3430359934528;
  fWeightMatrix0to1[16][8] = 0.735073010112455;
  fWeightMatrix0to1[0][9] = 2.78724100188525;
  fWeightMatrix0to1[1][9] = 0.433706526658955;
  fWeightMatrix0to1[2][9] = -0.96219063823104;
  fWeightMatrix0to1[3][9] = -2.70140686141717;
  fWeightMatrix0to1[4][9] = -0.265583697419081;
  fWeightMatrix0to1[5][9] = -1.72685948062053;
  fWeightMatrix0to1[6][9] = -0.108339262173006;
  fWeightMatrix0to1[7][9] = 1.54772335306304;
  fWeightMatrix0to1[8][9] = -1.10613842902648;
  fWeightMatrix0to1[9][9] = 0.469323170989803;
  fWeightMatrix0to1[10][9] = 0.970241321956252;
  fWeightMatrix0to1[11][9] = -1.59267202420104;
  fWeightMatrix0to1[12][9] = -0.784734694018746;
  fWeightMatrix0to1[13][9] = -0.226957516402606;
  fWeightMatrix0to1[14][9] = 1.31852635449082;
  fWeightMatrix0to1[15][9] = 1.86956693208752;
  fWeightMatrix0to1[16][9] = -2.76463450176151;
  fWeightMatrix0to1[0][10] = 0.279347972049474;
  fWeightMatrix0to1[1][10] = 2.26461124929956;
  fWeightMatrix0to1[2][10] = -2.24618811245207;
  fWeightMatrix0to1[3][10] = 1.5458894090246;
  fWeightMatrix0to1[4][10] = -1.95323731746994;
  fWeightMatrix0to1[5][10] = 3.64182725276194;
  fWeightMatrix0to1[6][10] = 0.0898920026086836;
  fWeightMatrix0to1[7][10] = -2.81227069347896;
  fWeightMatrix0to1[8][10] = -0.225335680199493;
  fWeightMatrix0to1[9][10] = 8.68676553144314;
  fWeightMatrix0to1[10][10] = 4.26677003221556;
  fWeightMatrix0to1[11][10] = 0.0942774370519825;
  fWeightMatrix0to1[12][10] = 3.53192699634111;
  fWeightMatrix0to1[13][10] = -1.39118629843063;
  fWeightMatrix0to1[14][10] = -1.01679937664302;
  fWeightMatrix0to1[15][10] = 1.33784439112834;
  fWeightMatrix0to1[16][10] = -0.516361943799491;
  fWeightMatrix0to1[0][11] = 1.57399012292995;
  fWeightMatrix0to1[1][11] = -0.338018842964414;
  fWeightMatrix0to1[2][11] = 0.351522230489223;
  fWeightMatrix0to1[3][11] = 2.73747051799465;
  fWeightMatrix0to1[4][11] = -1.28149783499414;
  fWeightMatrix0to1[5][11] = 0.853688576408981;
  fWeightMatrix0to1[6][11] = 1.64224198631134;
  fWeightMatrix0to1[7][11] = -0.862513438881274;
  fWeightMatrix0to1[8][11] = -2.91010728139147;
  fWeightMatrix0to1[9][11] = 0.415509964578044;
  fWeightMatrix0to1[10][11] = -0.777748505687989;
  fWeightMatrix0to1[11][11] = 0.585663249505778;
  fWeightMatrix0to1[12][11] = -1.3791307223233;
  fWeightMatrix0to1[13][11] = 1.86960988189268;
  fWeightMatrix0to1[14][11] = 0.911367456250669;
  fWeightMatrix0to1[15][11] = -1.3750625787368;
  fWeightMatrix0to1[16][11] = 1.61740484334239;
  fWeightMatrix0to1[0][12] = -0.264765853667604;
  fWeightMatrix0to1[1][12] = 0.71797460613632;
  fWeightMatrix0to1[2][12] = -0.653767879746068;
  fWeightMatrix0to1[3][12] = 0.174464492488714;
  fWeightMatrix0to1[4][12] = 0.774745080178751;
  fWeightMatrix0to1[5][12] = 1.14408027052281;
  fWeightMatrix0to1[6][12] = -0.0382442517632693;
  fWeightMatrix0to1[7][12] = -1.45380447635425;
  fWeightMatrix0to1[8][12] = 0.425739482250649;
  fWeightMatrix0to1[9][12] = -0.0949424367343536;
  fWeightMatrix0to1[10][12] = 0.876253663128819;
  fWeightMatrix0to1[11][12] = -0.367412058976651;
  fWeightMatrix0to1[12][12] = 1.86334998970694;
  fWeightMatrix0to1[13][12] = -1.44330706886827;
  fWeightMatrix0to1[14][12] = 0.608706420551827;
  fWeightMatrix0to1[15][12] = 1.20713842598177;
  fWeightMatrix0to1[16][12] = 1.20244330225056;
  fWeightMatrix0to1[0][13] = -1.1444677248276;
  fWeightMatrix0to1[1][13] = 1.42077287306063;
  fWeightMatrix0to1[2][13] = 0.80095525280376;
  fWeightMatrix0to1[3][13] = -1.46096373252071;
  fWeightMatrix0to1[4][13] = 1.35668028963541;
  fWeightMatrix0to1[5][13] = -0.517940703926034;
  fWeightMatrix0to1[6][13] = -0.294768534698517;
  fWeightMatrix0to1[7][13] = 1.00531342490485;
  fWeightMatrix0to1[8][13] = -1.70195921514704;
  fWeightMatrix0to1[9][13] = -1.33176822305359;
  fWeightMatrix0to1[10][13] = 3.8570476836394;
  fWeightMatrix0to1[11][13] = -1.91678425119976;
  fWeightMatrix0to1[12][13] = 1.13846166011785;
  fWeightMatrix0to1[13][13] = 0.533425137529391;
  fWeightMatrix0to1[14][13] = 0.446499993448349;
  fWeightMatrix0to1[15][13] = 1.86944960951551;
  fWeightMatrix0to1[16][13] = -2.30315855648802;
  fWeightMatrix0to1[0][14] = -0.476837833585106;
  fWeightMatrix0to1[1][14] = 1.12146135915522;
  fWeightMatrix0to1[2][14] = 0.0954160621856351;
  fWeightMatrix0to1[3][14] = 0.917950548802042;
  fWeightMatrix0to1[4][14] = -1.05857100834664;
  fWeightMatrix0to1[5][14] = 0.223177222940276;
  fWeightMatrix0to1[6][14] = -1.87655853943733;
  fWeightMatrix0to1[7][14] = -0.715278722690771;
  fWeightMatrix0to1[8][14] = 0.570096311960095;
  fWeightMatrix0to1[9][14] = -0.246674102897462;
  fWeightMatrix0to1[10][14] = -0.203288594685489;
  fWeightMatrix0to1[11][14] = 0.688567016397448;
  fWeightMatrix0to1[12][14] = -0.466055448303552;
  fWeightMatrix0to1[13][14] = 0.890112023274986;
  fWeightMatrix0to1[14][14] = 1.17813558999149;
  fWeightMatrix0to1[15][14] = -0.0580042348061085;
  fWeightMatrix0to1[16][14] = -0.396178788369235;
  fWeightMatrix0to1[0][15] = -0.158958519731501;
  fWeightMatrix0to1[1][15] = 2.2220190884963;
  fWeightMatrix0to1[2][15] = 3.04074750721323;
  fWeightMatrix0to1[3][15] = -0.837783036303397;
  fWeightMatrix0to1[4][15] = 1.41048839853502;
  fWeightMatrix0to1[5][15] = 3.83386434491793;
  fWeightMatrix0to1[6][15] = -1.53934667334982;
  fWeightMatrix0to1[7][15] = -0.574578138867153;
  fWeightMatrix0to1[8][15] = -0.332496225903962;
  fWeightMatrix0to1[9][15] = 2.04482631433596;
  fWeightMatrix0to1[10][15] = 2.20260527443635;
  fWeightMatrix0to1[11][15] = 0.510965967014974;
  fWeightMatrix0to1[12][15] = 5.24950246523099;
  fWeightMatrix0to1[13][15] = -0.149585791950679;
  fWeightMatrix0to1[14][15] = -2.86212964600436;
  fWeightMatrix0to1[15][15] = -1.43893503103713;
  fWeightMatrix0to1[16][15] = -1.07447598638702;
  fWeightMatrix0to1[0][16] = 2.01111365288346;
  fWeightMatrix0to1[1][16] = -0.0912941303529783;
  fWeightMatrix0to1[2][16] = 0.990472351028903;
  fWeightMatrix0to1[3][16] = -1.50612359216021;
  fWeightMatrix0to1[4][16] = -1.97139832780577;
  fWeightMatrix0to1[5][16] = 0.195025544552927;
  fWeightMatrix0to1[6][16] = 0.122170683540398;
  fWeightMatrix0to1[7][16] = -1.28860333099608;
  fWeightMatrix0to1[8][16] = -3.74154469176322;
  fWeightMatrix0to1[9][16] = 6.18934847974614;
  fWeightMatrix0to1[10][16] = -0.351664929134481;
  fWeightMatrix0to1[11][16] = -1.25081328595909;
  fWeightMatrix0to1[12][16] = 5.61481448086016;
  fWeightMatrix0to1[13][16] = -0.203078144533441;
  fWeightMatrix0to1[14][16] = -1.42028950950103;
  fWeightMatrix0to1[15][16] = -1.35204360084685;
  fWeightMatrix0to1[16][16] = -11.4894198976446;
  // weight matrix from layer 1 to 2
  fWeightMatrix1to2[0][0] = -0.615423354981741;
  fWeightMatrix1to2[1][0] = -0.375100985189579;
  fWeightMatrix1to2[2][0] = -0.250879083416565;
  fWeightMatrix1to2[3][0] = -1.02008165412082;
  fWeightMatrix1to2[4][0] = 1.28666217177728;
  fWeightMatrix1to2[5][0] = -0.426981418951039;
  fWeightMatrix1to2[6][0] = -0.398615771478148;
  fWeightMatrix1to2[7][0] = -0.0984679968932095;
  fWeightMatrix1to2[8][0] = 0.307122331656721;
  fWeightMatrix1to2[0][1] = -1.76396135668777;
  fWeightMatrix1to2[1][1] = 0.666884234904462;
  fWeightMatrix1to2[2][1] = 0.544132215027275;
  fWeightMatrix1to2[3][1] = 0.137651757858724;
  fWeightMatrix1to2[4][1] = -0.919763414612867;
  fWeightMatrix1to2[5][1] = -0.070516639553561;
  fWeightMatrix1to2[6][1] = -1.26397523518234;
  fWeightMatrix1to2[7][1] = 0.90734483396871;
  fWeightMatrix1to2[8][1] = 2.17444221463612;
  fWeightMatrix1to2[0][2] = 1.44222648196432;
  fWeightMatrix1to2[1][2] = 2.31158633943157;
  fWeightMatrix1to2[2][2] = 0.647646106455265;
  fWeightMatrix1to2[3][2] = -0.211741845478524;
  fWeightMatrix1to2[4][2] = -1.1408069182678;
  fWeightMatrix1to2[5][2] = -1.08290954613521;
  fWeightMatrix1to2[6][2] = 1.39496691979141;
  fWeightMatrix1to2[7][2] = -0.1856897959969;
  fWeightMatrix1to2[8][2] = -1.73494822043428;
  fWeightMatrix1to2[0][3] = -0.499675240797428;
  fWeightMatrix1to2[1][3] = 1.12369188540279;
  fWeightMatrix1to2[2][3] = -1.29285802022099;
  fWeightMatrix1to2[3][3] = 0.730261590666725;
  fWeightMatrix1to2[4][3] = -0.987901309349243;
  fWeightMatrix1to2[5][3] = -0.546658373763373;
  fWeightMatrix1to2[6][3] = 0.24154557466435;
  fWeightMatrix1to2[7][3] = -0.49689081636802;
  fWeightMatrix1to2[8][3] = -0.557357270941586;
  fWeightMatrix1to2[0][4] = -0.44602149900954;
  fWeightMatrix1to2[1][4] = 0.0351045450342672;
  fWeightMatrix1to2[2][4] = 1.73053388252015;
  fWeightMatrix1to2[3][4] = 0.0220218347385526;
  fWeightMatrix1to2[4][4] = -1.43895148122016;
  fWeightMatrix1to2[5][4] = -0.30173976224248;
  fWeightMatrix1to2[6][4] = -0.824042574415497;
  fWeightMatrix1to2[7][4] = -0.240566094405949;
  fWeightMatrix1to2[8][4] = -0.84772558816992;
  fWeightMatrix1to2[0][5] = -1.49291701456516;
  fWeightMatrix1to2[1][5] = -1.1105083269294;
  fWeightMatrix1to2[2][5] = 0.611999109937384;
  fWeightMatrix1to2[3][5] = 0.994689515593263;
  fWeightMatrix1to2[4][5] = 0.523475462301141;
  fWeightMatrix1to2[5][5] = -0.262457701707309;
  fWeightMatrix1to2[6][5] = -0.965755045606405;
  fWeightMatrix1to2[7][5] = -1.72736799228321;
  fWeightMatrix1to2[8][5] = -1.64469719296802;
  fWeightMatrix1to2[0][6] = -1.72374857078442;
  fWeightMatrix1to2[1][6] = -0.0846394401758822;
  fWeightMatrix1to2[2][6] = 1.34861528682925;
  fWeightMatrix1to2[3][6] = 0.94076078738548;
  fWeightMatrix1to2[4][6] = -0.746019853540259;
  fWeightMatrix1to2[5][6] = -1.6562940219943;
  fWeightMatrix1to2[6][6] = -1.32754220472988;
  fWeightMatrix1to2[7][6] = -1.40873179787795;
  fWeightMatrix1to2[8][6] = 0.0336361944126289;
  fWeightMatrix1to2[0][7] = -0.52850915721164;
  fWeightMatrix1to2[1][7] = -0.00419581086151006;
  fWeightMatrix1to2[2][7] = -0.0522888994074652;
  fWeightMatrix1to2[3][7] = 1.22007012996178;
  fWeightMatrix1to2[4][7] = -1.99053277328623;
  fWeightMatrix1to2[5][7] = -0.342770652181222;
  fWeightMatrix1to2[6][7] = 0.894338053715044;
  fWeightMatrix1to2[7][7] = -0.813623171534041;
  fWeightMatrix1to2[8][7] = -1.35635448425339;
  fWeightMatrix1to2[0][8] = 1.23610155845466;
  fWeightMatrix1to2[1][8] = -0.986704944017535;
  fWeightMatrix1to2[2][8] = -0.675617805701485;
  fWeightMatrix1to2[3][8] = -1.44377123308793;
  fWeightMatrix1to2[4][8] = -0.85406679088648;
  fWeightMatrix1to2[5][8] = -0.401804228720925;
  fWeightMatrix1to2[6][8] = 0.293522209513889;
  fWeightMatrix1to2[7][8] = -1.00761188922386;
  fWeightMatrix1to2[8][8] = -1.37657181974876;
  fWeightMatrix1to2[0][9] = -0.504258887904233;
  fWeightMatrix1to2[1][9] = -0.995200255104558;
  fWeightMatrix1to2[2][9] = 0.235939247554207;
  fWeightMatrix1to2[3][9] = -1.92948729940208;
  fWeightMatrix1to2[4][9] = -0.533156732893678;
  fWeightMatrix1to2[5][9] = -0.41358652776982;
  fWeightMatrix1to2[6][9] = -0.315754444292006;
  fWeightMatrix1to2[7][9] = -3.03442176768374;
  fWeightMatrix1to2[8][9] = 1.17035745883912;
  fWeightMatrix1to2[0][10] = -1.11745692277904;
  fWeightMatrix1to2[1][10] = -0.132702128469675;
  fWeightMatrix1to2[2][10] = 0.777962672369477;
  fWeightMatrix1to2[3][10] = -2.43242922535208;
  fWeightMatrix1to2[4][10] = -1.56884325936331;
  fWeightMatrix1to2[5][10] = -0.624325255241324;
  fWeightMatrix1to2[6][10] = -0.285829684102288;
  fWeightMatrix1to2[7][10] = -1.43487679523596;
  fWeightMatrix1to2[8][10] = 0.0538702826848946;
  fWeightMatrix1to2[0][11] = -1.87812647751184;
  fWeightMatrix1to2[1][11] = -1.17342468854833;
  fWeightMatrix1to2[2][11] = 1.30810095199791;
  fWeightMatrix1to2[3][11] = -0.891161343493334;
  fWeightMatrix1to2[4][11] = 0.787705024177259;
  fWeightMatrix1to2[5][11] = 1.49291218653364;
  fWeightMatrix1to2[6][11] = 1.88557483392674;
  fWeightMatrix1to2[7][11] = -1.02908575402087;
  fWeightMatrix1to2[8][11] = 1.35839360888555;
  fWeightMatrix1to2[0][12] = 1.39742991096995;
  fWeightMatrix1to2[1][12] = 0.265329256488366;
  fWeightMatrix1to2[2][12] = 0.602523267081653;
  fWeightMatrix1to2[3][12] = -0.740723755272065;
  fWeightMatrix1to2[4][12] = 0.74667044197212;
  fWeightMatrix1to2[5][12] = 0.0110242263871607;
  fWeightMatrix1to2[6][12] = -1.92421200731146;
  fWeightMatrix1to2[7][12] = 0.848539833549426;
  fWeightMatrix1to2[8][12] = -0.157706232271325;
  fWeightMatrix1to2[0][13] = 0.990526880802358;
  fWeightMatrix1to2[1][13] = 0.827286680673599;
  fWeightMatrix1to2[2][13] = 1.40690951270793;
  fWeightMatrix1to2[3][13] = 0.293603819694401;
  fWeightMatrix1to2[4][13] = -0.00777175955483867;
  fWeightMatrix1to2[5][13] = -1.93705501791793;
  fWeightMatrix1to2[6][13] = -1.57176948338914;
  fWeightMatrix1to2[7][13] = -1.8432459592403;
  fWeightMatrix1to2[8][13] = 1.07131493321207;
  fWeightMatrix1to2[0][14] = 1.28882729573868;
  fWeightMatrix1to2[1][14] = 0.556379149254852;
  fWeightMatrix1to2[2][14] = -0.0650283073181004;
  fWeightMatrix1to2[3][14] = -1.68664885385176;
  fWeightMatrix1to2[4][14] = -1.15609583794774;
  fWeightMatrix1to2[5][14] = 0.940356561112683;
  fWeightMatrix1to2[6][14] = -1.24289724648297;
  fWeightMatrix1to2[7][14] = 1.32006882774092;
  fWeightMatrix1to2[8][14] = -1.55673389774801;
  fWeightMatrix1to2[0][15] = -1.24494492203347;
  fWeightMatrix1to2[1][15] = -0.231361572274765;
  fWeightMatrix1to2[2][15] = 1.32974811854605;
  fWeightMatrix1to2[3][15] = -0.376143808755905;
  fWeightMatrix1to2[4][15] = 1.95373089916048;
  fWeightMatrix1to2[5][15] = -1.32454942989476;
  fWeightMatrix1to2[6][15] = 0.942663859128724;
  fWeightMatrix1to2[7][15] = -1.34949385391914;
  fWeightMatrix1to2[8][15] = -0.451936169140526;
  fWeightMatrix1to2[0][16] = -0.49620032522319;
  fWeightMatrix1to2[1][16] = 0.0481520363065841;
  fWeightMatrix1to2[2][16] = -0.831078181722343;
  fWeightMatrix1to2[3][16] = -0.0473907205602248;
  fWeightMatrix1to2[4][16] = -0.572175145606378;
  fWeightMatrix1to2[5][16] = -0.713556795595839;
  fWeightMatrix1to2[6][16] = 1.48749735119382;
  fWeightMatrix1to2[7][16] = -0.626643499119561;
  fWeightMatrix1to2[8][16] = -0.946630753437904;
  fWeightMatrix1to2[0][17] = -0.45252354270261;
  fWeightMatrix1to2[1][17] = -1.09472769515355;
  fWeightMatrix1to2[2][17] = 0.58448575006689;
  fWeightMatrix1to2[3][17] = -1.50429453862246;
  fWeightMatrix1to2[4][17] = 1.5973509836917;
  fWeightMatrix1to2[5][17] = 3.50159817106388;
  fWeightMatrix1to2[6][17] = -1.21970644127669;
  fWeightMatrix1to2[7][17] = 1.54308133902994;
  fWeightMatrix1to2[8][17] = 1.71074906744807;
  // weight matrix from layer 2 to 3
  fWeightMatrix2to3[0][0] = -0.566274840953027;
  fWeightMatrix2to3[1][0] = 0.871521916622914;
  fWeightMatrix2to3[2][0] = -0.498342970822928;
  fWeightMatrix2to3[3][0] = 0.521165960687891;
  fWeightMatrix2to3[4][0] = -1.58540205854568;
  fWeightMatrix2to3[0][1] = 0.29761093952585;
  fWeightMatrix2to3[1][1] = -0.151697764445653;
  fWeightMatrix2to3[2][1] = -0.373132160867578;
  fWeightMatrix2to3[3][1] = -0.027118718588117;
  fWeightMatrix2to3[4][1] = 0.378885077691616;
  fWeightMatrix2to3[0][2] = -2.00498284190948;
  fWeightMatrix2to3[1][2] = -1.18611164318418;
  fWeightMatrix2to3[2][2] = 0.53433781934441;
  fWeightMatrix2to3[3][2] = -0.733615810344071;
  fWeightMatrix2to3[4][2] = -0.843064100167125;
  fWeightMatrix2to3[0][3] = -0.210502909672685;
  fWeightMatrix2to3[1][3] = 0.13271541449742;
  fWeightMatrix2to3[2][3] = -0.90351922167926;
  fWeightMatrix2to3[3][3] = 1.25226197792368;
  fWeightMatrix2to3[4][3] = -0.979059687291062;
  fWeightMatrix2to3[0][4] = -1.16027994365158;
  fWeightMatrix2to3[1][4] = -0.610373721852304;
  fWeightMatrix2to3[2][4] = 0.670872331405716;
  fWeightMatrix2to3[3][4] = -1.80841765534131;
  fWeightMatrix2to3[4][4] = -1.85779597565641;
  fWeightMatrix2to3[0][5] = -0.387695977801258;
  fWeightMatrix2to3[1][5] = -0.455269797612066;
  fWeightMatrix2to3[2][5] = -0.64511991230428;
  fWeightMatrix2to3[3][5] = -1.43783738184052;
  fWeightMatrix2to3[4][5] = -0.966591411435813;
  fWeightMatrix2to3[0][6] = -1.46594513261294;
  fWeightMatrix2to3[1][6] = -1.74249886592673;
  fWeightMatrix2to3[2][6] = -0.59071205778875;
  fWeightMatrix2to3[3][6] = -2.59640855176981;
  fWeightMatrix2to3[4][6] = -1.26146316051782;
  fWeightMatrix2to3[0][7] = 0.700114585113138;
  fWeightMatrix2to3[1][7] = 2.042845352681;
  fWeightMatrix2to3[2][7] = -1.17031366034372;
  fWeightMatrix2to3[3][7] = 0.529386601344605;
  fWeightMatrix2to3[4][7] = -0.211286574155499;
  fWeightMatrix2to3[0][8] = -0.380722547713221;
  fWeightMatrix2to3[1][8] = 0.214384832986399;
  fWeightMatrix2to3[2][8] = 0.589355854993973;
  fWeightMatrix2to3[3][8] = -1.21391458239251;
  fWeightMatrix2to3[4][8] = -0.911404739651994;
  fWeightMatrix2to3[0][9] = -1.2049993483518;
  fWeightMatrix2to3[1][9] = -1.20296294426666;
  fWeightMatrix2to3[2][9] = 3.46082187924377;
  fWeightMatrix2to3[3][9] = -2.85190740408304e-05;
  fWeightMatrix2to3[4][9] = -0.00309424763832636;
  // weight matrix from layer 3 to 4
  fWeightMatrix3to4[0][0] = 1.06876149191014;
  fWeightMatrix3to4[0][1] = -0.791821654832949;
  fWeightMatrix3to4[0][2] = -1.26886371573461;
  fWeightMatrix3to4[0][3] = 0.895625370460543;
  fWeightMatrix3to4[0][4] = 0.327202365595515;
  fWeightMatrix3to4[0][5] = 4.50276086330653;
}

inline double ReadASFDeep::GetMvaValue__( const std::vector<double>& inputValues ) const
{
  if (inputValues.size() != (unsigned int)fLayerSize[0]-1) {
    std::cout << "Input vector needs to be of size " << fLayerSize[0]-1 << std::endl;
    return 0;
  }

  for (int l=0; l<fLayers; l++)
    for (int i=0; i<fLayerSize[l]; i++) fWeights[l][i]=0;

  for (int l=0; l<fLayers-1; l++)
    fWeights[l][fLayerSize[l]-1]=1;

  for (int i=0; i<fLayerSize[0]-1; i++)
    fWeights[0][i]=inputValues[i];

  // layer 0 to 1
  for (int o=0; o<fLayerSize[1]-1; o++) {
    for (int i=0; i<fLayerSize[0]; i++) {
      double inputVal = fWeightMatrix0to1[o][i] * fWeights[0][i];
      fWeights[1][o] += inputVal;
    }
    fWeights[1][o] = ActivationFnc(fWeights[1][o]);
  }
  // layer 1 to 2
  for (int o=0; o<fLayerSize[2]-1; o++) {
    for (int i=0; i<fLayerSize[1]; i++) {
      double inputVal = fWeightMatrix1to2[o][i] * fWeights[1][i];
      fWeights[2][o] += inputVal;
    }
    fWeights[2][o] = ActivationFnc(fWeights[2][o]);
  }
  // layer 2 to 3
  for (int o=0; o<fLayerSize[3]-1; o++) {
    for (int i=0; i<fLayerSize[2]; i++) {
      double inputVal = fWeightMatrix2to3[o][i] * fWeights[2][i];
      fWeights[3][o] += inputVal;
    }
    fWeights[3][o] = ActivationFnc(fWeights[3][o]);
  }
  // layer 3 to 4
  for (int o=0; o<fLayerSize[4]; o++) {
    for (int i=0; i<fLayerSize[3]; i++) {
      double inputVal = fWeightMatrix3to4[o][i] * fWeights[3][i];
      fWeights[4][o] += inputVal;
    }
    fWeights[4][o] = OutputActivationFnc(fWeights[4][o]);
  }

  return fWeights[4][0];
}

double ReadASFDeep::ActivationFnc(double x) const {
  // rectified linear unit
  return x>0 ? x : 0;
}
double ReadASFDeep::OutputActivationFnc(double x) const {
  // sigmoid
  return 1.0/(1.0+exp(-x));
}

// Clean up
inline void ReadASFDeep::Clear()
{
  // clean up the arrays
  for (int lIdx = 0; lIdx < 5; lIdx++) {
    delete[] fWeights[lIdx];
  }
}
inline double ReadASFDeep::GetMvaValue( std::vector<double>& inputValues ) const
{
  // classifier response value
  double retval = 0;

  // classifier response, sanity check first
  if (!IsStatusClean()) {
    std::cout << "Problem in class \"" << fClassName << "\": cannot return classifier response"
              << " because status is dirty" << std::endl;
    retval = 0;
  }
  else {
    if (IsNormalised()) {
      // normalise variables
      std::vector<double> iV;
      iV.reserve(inputValues.size());
      int ivar = 0;
      for (auto varIt = inputValues.begin();
           varIt != inputValues.end(); varIt++, ivar++) {
        iV.push_back(NormVariable( *varIt, fVmin[ivar], fVmax[ivar] ));
      }
      Transform( iV, -1 );
      retval = GetMvaValue__( iV );
    }
    else {
      Transform( inputValues, -1 );
      retval = GetMvaValue__( inputValues );
    }
  }

  return retval;
}

//_______________________________________________________________________
inline void ReadASFDeep::InitTransform_1()
{
  // Normalization transformation, initialisation
  fMin_1[0][0] = 0.0129130277783;
  fMax_1[0][0] = 4.42646932602;
  fMin_1[1][0] = 0.0305624548346;
  fMax_1[1][0] = 22.3806743622;
  fMin_1[2][0] = 0.0129130277783;
  fMax_1[2][0] = 22.3806743622;
  fMin_1[0][1] = 0.0221927668899;
  fMax_1[0][1] = 14.3583307266;
  fMin_1[1][1] = 0.0333003401756;
  fMax_1[1][1] = 33.4279251099;
  fMin_1[2][1] = 0.0221927668899;
  fMax_1[2][1] = 33.4279251099;
  fMin_1[0][2] = 0.0645651370287;
  fMax_1[0][2] = 39.440738678;
  fMin_1[1][2] = 0.0931389853358;
  fMax_1[1][2] = 89.5226974487;
  fMin_1[2][2] = 0.0645651370287;
  fMax_1[2][2] = 89.5226974487;
  fMin_1[0][3] = 8;
  fMax_1[0][3] = 45;
  fMin_1[1][3] = 7;
  fMax_1[1][3] = 40;
  fMin_1[2][3] = 7;
  fMax_1[2][3] = 45;
  fMin_1[0][4] = -2741.375;
  fMax_1[0][4] = 2794.3125;
  fMin_1[1][4] = -2777.8125;
  fMax_1[1][4] = 2701.125;
  fMin_1[2][4] = -2777.8125;
  fMax_1[2][4] = 2794.3125;
  fMin_1[0][5] = 6;
  fMax_1[0][5] = 12;
  fMin_1[1][5] = 5;
  fMax_1[1][5] = 12;
  fMin_1[2][5] = 5;
  fMax_1[2][5] = 12;
  fMin_1[0][6] = -0.415202230215;
  fMax_1[0][6] = 0.413399279118;
  fMin_1[1][6] = -0.436507284641;
  fMax_1[1][6] = 0.504935562611;
  fMin_1[2][6] = -0.436507284641;
  fMax_1[2][6] = 0.504935562611;
  fMin_1[0][7] = -0.272994011641;
  fMax_1[0][7] = 0.274604618549;
  fMin_1[1][7] = -0.278397083282;
  fMax_1[1][7] = 0.277494072914;
  fMin_1[2][7] = -0.278397083282;
  fMax_1[2][7] = 0.277494072914;
  fMin_1[0][8] = -2.52560138702;
  fMax_1[0][8] = 2.41754245758;
  fMin_1[1][8] = -2.53470730782;
  fMax_1[1][8] = 6.00070905685;
  fMin_1[2][8] = -2.53470730782;
  fMax_1[2][8] = 6.00070905685;
  fMin_1[0][9] = -2.86267995834;
  fMax_1[0][9] = 7.25548362732;
  fMin_1[1][9] = -2.30405211449;
  fMax_1[1][9] = 7.60771226883;
  fMin_1[2][9] = -2.86267995834;
  fMax_1[2][9] = 7.60771226883;
  fMin_1[0][10] = 0.1761457026;
  fMax_1[0][10] = 5.71294116974;
  fMin_1[1][10] = 0.000701896322425;
  fMax_1[1][10] = 9.39501285553;
  fMin_1[2][10] = 0.000701896322425;
  fMax_1[2][10] = 9.39501285553;
  fMin_1[0][11] = -1.03266918659;
  fMax_1[0][11] = 1.0124515295;
  fMin_1[1][11] = -1.20764863491;
  fMax_1[1][11] = 1.30925452709;
  fMin_1[2][11] = -1.20764863491;
  fMax_1[2][11] = 1.30925452709;
  fMin_1[0][12] = -1.23058617115;
  fMax_1[0][12] = 1.26629555225;
  fMin_1[1][12] = -1.49837112427;
  fMax_1[1][12] = 1.47500002384;
  fMin_1[2][12] = -1.49837112427;
  fMax_1[2][12] = 1.47500002384;
  fMin_1[0][13] = -9728.40234375;
  fMax_1[0][13] = 10495.8037109;
  fMin_1[1][13] = -18131.1601562;
  fMax_1[1][13] = 14743.1650391;
  fMin_1[2][13] = -18131.1601562;
  fMax_1[2][13] = 14743.1650391;
  fMin_1[0][14] = 2;
  fMax_1[0][14] = 6;
  fMin_1[1][14] = 2;
  fMax_1[1][14] = 6;
  fMin_1[2][14] = 2;
  fMax_1[2][14] = 6;
  fMin_1[0][15] = 1.8642298528e-05;
  fMax_1[0][15] = 1.76702034473;
  fMin_1[1][15] = 2.5816832931e-05;
  fMax_1[1][15] = 2.68636751175;
  fMin_1[2][15] = 1.8642298528e-05;
  fMax_1[2][15] = 2.68636751175;
}

//_______________________________________________________________________
inline void ReadASFDeep::Transform_1( std::vector<double>& iv, int cls) const
{
  // Normalization transformation
  if (cls < 0 || cls > 2) {
     cls = 2;
  }

  for (int ivar=0;ivar<16;ivar++) {
    double offset = fMin_1[cls][ivar];
    double scale  = 1.0/(fMax_1[cls][ivar]-fMin_1[cls][ivar]);
    iv[ivar] = (iv[ivar]-offset)*scale * 2 - 1;
  }
}

//_______________________________________________________________________
inline void ReadASFDeep::InitTransform()
{
  InitTransform_1();
}

//_______________________________________________________________________
inline void ReadASFDeep::Transform( std::vector<double>& iv, int sigOrBgd ) const
{
  Transform_1( iv, sigOrBgd );
}
