// Class: ReadMLPBNN
// Automatically generated by MethodBase::MakeClass
//

/* configuration options =====================================================

#GEN -*-*-*-*-*-*-*-*-*-*-*- general info -*-*-*-*-*-*-*-*-*-*-*-

Method         : MLP::MLPBNN
TMVA Release   : 4.2.1         [262657]
ROOT Release   : 6.08/02       [395266]
Creator        : decianm
Date           : Tue Mar 14 22:30:30 2017
Host           : Linux lcgapp-slc6-physical1.cern.ch 2.6.32-642.4.2.el6.x86_64 #1 SMP Wed Aug 24 09:19:54 CEST 2016 x86_64 x86_64 x86_64 GNU/Linux
Dir            : /afs/cern.ch/user/d/decianm/lhcbSoftware/test/BrunelDev_HEAD/tunePatLLT
Training events: 2000
Analysis type  : [Classification]


#OPT -*-*-*-*-*-*-*-*-*-*-*-*- options -*-*-*-*-*-*-*-*-*-*-*-*-

# Set by User:
NCycles: "600" [Number of training cycles]
HiddenLayers: "N+5" [Specification of hidden layer architecture]
NeuronType: "ReLU" [Neuron activation function type]
EstimatorType: "CE" [MSE (Mean Square Estimator) for Gaussian Likelihood or CE(Cross-Entropy) for Bernoulli Likelihood]
V: "False" [Verbose output (short form of "VerbosityLevel" below - overrides the latter one)]
VarTransform: "N" [List of variable transformations performed before training, e.g., "D_Background,P_Signal,G,N_AllClasses" for: "Decorrelation, PCA-transformation, Gaussianisation, Normalisation, each for the given class of events ('AllClasses' denotes all events of all classes, if no class indication is given, 'All' is assumed)"]
H: "True" [Print method-specific help message]
TrainingMethod: "BFGS" [Train with Back-Propagation (BP), BFGS Algorithm (BFGS), or Genetic Algorithm (GA - slower and worse)]
TestRate: "5" [Test for overtraining performed at each #th epochs]
UseRegulator: "True" [Use regulator to avoid over-training]
# Default:
RandomSeed: "1" [Random seed for initial synapse weights (0 means unique seed for each run; default value '1')]
NeuronInputType: "sum" [Neuron input function type]
VerbosityLevel: "Default" [Verbosity level]
CreateMVAPdfs: "False" [Create PDFs for classifier outputs (signal and background)]
IgnoreNegWeightsInTraining: "False" [Events with negative weights are ignored in the training (but are included for testing and performance evaluation)]
LearningRate: "2.000000e-02" [ANN learning rate parameter]
DecayRate: "1.000000e-02" [Decay rate for learning parameter]
EpochMonitoring: "False" [Provide epoch-wise monitoring plots according to TestRate (caution: causes big ROOT output file!)]
Sampling: "1.000000e+00" [Only 'Sampling' (randomly selected) events are trained each epoch]
SamplingEpoch: "1.000000e+00" [Sampling is used for the first 'SamplingEpoch' epochs, afterwards, all events are taken for training]
SamplingImportance: "1.000000e+00" [ The sampling weights of events in epochs which successful (worse estimator than before) are multiplied with SamplingImportance, else they are divided.]
SamplingTraining: "True" [The training sample is sampled]
SamplingTesting: "False" [The testing sample is sampled]
ResetStep: "50" [How often BFGS should reset history]
Tau: "3.000000e+00" [LineSearch "size step"]
BPMode: "sequential" [Back-propagation learning mode: sequential or batch]
BatchSize: "-1" [Batch size: number of events/batch, only set if in Batch Mode, -1 for BatchSize=number_of_events]
ConvergenceImprove: "1.000000e-30" [Minimum improvement which counts as improvement (<0 means automatic convergence check is turned off)]
ConvergenceTests: "-1" [Number of steps (without improvement) required for convergence (<0 means automatic convergence check is turned off)]
UpdateLimit: "10000" [Maximum times of regulator update]
CalculateErrors: "False" [Calculates inverse Hessian matrix at the end of the training to be able to calculate the uncertainties of an MVA value]
WeightRange: "1.000000e+00" [Take the events for the estimator calculations from small deviations from the desired value to large deviations only over the weight range]
##


#VAR -*-*-*-*-*-*-*-*-*-*-*-* variables *-*-*-*-*-*-*-*-*-*-*-*-

NVar 9
logChi2                       logChi2                       logChi2                       logChi2                                                         'F'    [-4.2236661911,3.9046216011]
logP                          logP                          logP                          logP                                                            'F'    [7.24498987198,11.9081087112]
logPt                         logPt                         logPt                         logPt                                                           'F'    [3.3211350441,8.50529193878]
deltaP                        deltaP                        deltaP                        deltaP                                                          'F'    [1.30815415105e-05,0.280173331499]
logDxMagnet                   logDxMagnet                   logDxMagnet                   logDxMagnet                                                     'F'    [-4.96382665634,4.9918179512]
logDistance                   logDistance                   logDistance                   logDistance                                                     'F'    [-7.98678255081,4.8268237114]
logYAt0                       logYAt0                       logYAt0                       logYAt0                                                         'F'    [-8.60095500946,5.82908582687]
logXAt0                       logXAt0                       logXAt0                       logXAt0                                                         'F'    [-5.93340778351,5.69148921967]
firedLayers                   firedLayers                   firedLayers                   firedLayers                                                     'I'    [3,4]
NSpec 1
goodTrack                     goodTrack                     goodTrack                     F                                                               'F'    [0,1]


============================================================================ */

#include <vector>
#include <cmath>
#include <string>
#include <iostream>

#include "vdt/exp.h"

#ifndef IClassifierReader__def
#define IClassifierReader__def

class IClassifierReader {

 public:

   // constructor
   IClassifierReader() : fStatusIsClean( true ) {}
   virtual ~IClassifierReader() {}

   // return classifier response
  virtual double GetMvaValue( const std::array<double,9>& inputValues ) const = 0;

   // returns classifier status
   bool IsStatusClean() const { return fStatusIsClean; }

 protected:

   bool fStatusIsClean;
};

#endif

class ReadMLPBNN : public IClassifierReader {

public:

  // constructor
  ReadMLPBNN( const std::vector<std::string>& theInputVars ) 
    : IClassifierReader(),
      fClassName( "ReadMLPBNN" ),
      fNvars( 9 ),
      fIsNormalised( false )
  {      
    // the training input variables
    const char* inputVars[] = { "logChi2", "logP", "logPt", "deltaP", "logDxMagnet", "logDistance", "logYAt0", "logXAt0", "firedLayers" };
    
    // sanity checks
    if (theInputVars.size() <= 0) {
      std::cout << "Problem in class \"" << fClassName << "\": empty input vector" << std::endl;
      fStatusIsClean = false;
    }
    
    if (theInputVars.size() != fNvars) {
      std::cout << "Problem in class \"" << fClassName << "\": mismatch in number of input values: "
                << theInputVars.size() << " != " << fNvars << std::endl;
      fStatusIsClean = false;
    }
    
    // validate input variables
    for (size_t ivar = 0; ivar < theInputVars.size(); ivar++) {
      if (theInputVars[ivar] != inputVars[ivar]) {
        std::cout << "Problem in class \"" << fClassName << "\": mismatch in input variable names" << std::endl
                  << " for variable [" << ivar << "]: " << theInputVars[ivar].c_str() << " != " << inputVars[ivar] << std::endl;
        fStatusIsClean = false;
      }
    }
    
    // initialize min and max vectors (for normalisation)
    fVmin[0] = -1;
    fVmax[0] = 1;
    fVmin[1] = -1;
    fVmax[1] = 1;
    fVmin[2] = -1;
    fVmax[2] = 1;
    fVmin[3] = -1;
    fVmax[3] = 1;
    fVmin[4] = -1;
    fVmax[4] = 1;
    fVmin[5] = -1;
    fVmax[5] = 1;
    fVmin[6] = -1;
    fVmax[6] = 1;
    fVmin[7] = -1;
    fVmax[7] = 1;
    fVmin[8] = -1;
    fVmax[8] = 1;
    
    // initialize input variable types
    fType[0] = 'F';
    fType[1] = 'F';
    fType[2] = 'F';
    fType[3] = 'F';
    fType[4] = 'F';
    fType[5] = 'F';
    fType[6] = 'F';
    fType[7] = 'F';
    fType[8] = 'I';
    
    // initialize constants
    Initialize();
    
    // initialize transformation
    InitTransform();
  }
  
  // destructor
  virtual ~ReadMLPBNN() {
    Clear(); // method-specific
  }
  
  // the classifier response
  // "inputValues" is a vector of input values in the same order as the 
  // variables given to the constructor
  double GetMvaValue( const std::array<double,9>& inputValues ) const override;
  
private:
  
  // method-specific destructor
  void Clear();
  
  // input variable transformation
  
  double fMin_1[3][9];
  double fMax_1[3][9];
  void InitTransform_1();
  void Transform_1( std::array<double,9> & iv, int sigOrBgd ) const;
  void InitTransform();
  void Transform( std::array<double,9> & iv, int sigOrBgd ) const;
  
  // common member variables
  const char* fClassName;
  
  const size_t fNvars;
  size_t GetNvar()           const { return fNvars; }
  char   GetType( int ivar ) const { return fType[ivar]; }
  
  // normalisation of input variables
  const bool fIsNormalised;
  bool IsNormalised() const { return fIsNormalised; }
  double fVmin[9];
  double fVmax[9];
  double NormVariable( double x, double xmin, double xmax ) const {
    // normalise to output range: [-1, 1]
    return 2*(x - xmin)/(xmax - xmin) - 1.0;
  }
  
  // type of input variable: 'F' or 'I'
  char   fType[9];
  
  // initialize internal variables
  void Initialize();
  double GetMvaValue__( const std::array<double,9>& inputValues ) const;
  
  // private members (method specific)
  
  double ActivationFnc(double x) const;
  double OutputActivationFnc(double x) const;
  
  int fLayers;
  int fLayerSize[3];
  double fWeightMatrix0to1[15][10];   // weight matrix from layer 0 to 1
  double fWeightMatrix1to2[1][15];   // weight matrix from layer 1 to 2
  
  double * fWeights[3];
};

inline void ReadMLPBNN::Initialize()
{
   // build network structure
  fLayers = 3;
  fLayerSize[0] = 10; fWeights[0] = new double[10]; 
  fLayerSize[1] = 15; fWeights[1] = new double[15]; 
  fLayerSize[2] = 1; fWeights[2] = new double[1]; 
  // weight matrix from layer 0 to 1
  fWeightMatrix0to1[0][0] = 0.0112568675597735;
  fWeightMatrix0to1[1][0] = 0.0602828565032346;
  fWeightMatrix0to1[2][0] = 0.0184786640924334;
  fWeightMatrix0to1[3][0] = 0.30903455213345;
  fWeightMatrix0to1[4][0] = 0.163694529745755;
  fWeightMatrix0to1[5][0] = -0.0150042482653196;
  fWeightMatrix0to1[6][0] = 0.0816681221467318;
  fWeightMatrix0to1[7][0] = -0.015934257843886;
  fWeightMatrix0to1[8][0] = 0.0249730251148262;
  fWeightMatrix0to1[9][0] = -0.281811779623431;
  fWeightMatrix0to1[10][0] = -0.279861364672357;
  fWeightMatrix0to1[11][0] = -0.141960615013564;
  fWeightMatrix0to1[12][0] = -0.106927245629226;
  fWeightMatrix0to1[13][0] = -0.159257005224528;
  fWeightMatrix0to1[0][1] = -0.105647322974086;
  fWeightMatrix0to1[1][1] = -0.286790593709469;
  fWeightMatrix0to1[2][1] = 0.0446417758204926;
  fWeightMatrix0to1[3][1] = 0.415675460863538;
  fWeightMatrix0to1[4][1] = -0.19970168072515;
  fWeightMatrix0to1[5][1] = -0.0392107013078492;
  fWeightMatrix0to1[6][1] = 0.127597548460742;
  fWeightMatrix0to1[7][1] = -0.0573362382636405;
  fWeightMatrix0to1[8][1] = -0.00526010561627639;
  fWeightMatrix0to1[9][1] = -0.22798144872906;
  fWeightMatrix0to1[10][1] = 0.0310551870245549;
  fWeightMatrix0to1[11][1] = -0.205426125905574;
  fWeightMatrix0to1[12][1] = -0.237167489366324;
  fWeightMatrix0to1[13][1] = -0.208158606604287;
  fWeightMatrix0to1[0][2] = 0.0380894807285149;
  fWeightMatrix0to1[1][2] = -0.12353158907686;
  fWeightMatrix0to1[2][2] = -0.0957181250967226;
  fWeightMatrix0to1[3][2] = -0.148432300904739;
  fWeightMatrix0to1[4][2] = -0.141309842273083;
  fWeightMatrix0to1[5][2] = 0.00452798411315805;
  fWeightMatrix0to1[6][2] = 0.0177100491326079;
  fWeightMatrix0to1[7][2] = -0.0791297095600722;
  fWeightMatrix0to1[8][2] = -0.100761209515486;
  fWeightMatrix0to1[9][2] = 0.214184889439707;
  fWeightMatrix0to1[10][2] = -0.223310061373728;
  fWeightMatrix0to1[11][2] = 0.207585594968148;
  fWeightMatrix0to1[12][2] = 0.00972640525660315;
  fWeightMatrix0to1[13][2] = 0.085692876356606;
  fWeightMatrix0to1[0][3] = -0.0485651322371728;
  fWeightMatrix0to1[1][3] = 0.429065431633819;
  fWeightMatrix0to1[2][3] = -0.0534575225171453;
  fWeightMatrix0to1[3][3] = -0.171574970398527;
  fWeightMatrix0to1[4][3] = 0.0315459667944384;
  fWeightMatrix0to1[5][3] = -0.0144824466413439;
  fWeightMatrix0to1[6][3] = -0.00632094346149712;
  fWeightMatrix0to1[7][3] = 0.196197834100291;
  fWeightMatrix0to1[8][3] = 0.363499227254043;
  fWeightMatrix0to1[9][3] = 0.134676167036408;
  fWeightMatrix0to1[10][3] = -0.0577810151739701;
  fWeightMatrix0to1[11][3] = 0.104494547882347;
  fWeightMatrix0to1[12][3] = -0.102502852207234;
  fWeightMatrix0to1[13][3] = -0.0936616930937032;
  fWeightMatrix0to1[0][4] = 0.0942080306982564;
  fWeightMatrix0to1[1][4] = -0.23106656537217;
  fWeightMatrix0to1[2][4] = 0.118588131549325;
  fWeightMatrix0to1[3][4] = 0.146198029610207;
  fWeightMatrix0to1[4][4] = -0.290568916228159;
  fWeightMatrix0to1[5][4] = -0.00589093670240257;
  fWeightMatrix0to1[6][4] = -0.0458732458108749;
  fWeightMatrix0to1[7][4] = -0.011293929620576;
  fWeightMatrix0to1[8][4] = 0.124269525982082;
  fWeightMatrix0to1[9][4] = -0.222333472520718;
  fWeightMatrix0to1[10][4] = 0.247985651217165;
  fWeightMatrix0to1[11][4] = -0.390598206172806;
  fWeightMatrix0to1[12][4] = -0.0388391522021958;
  fWeightMatrix0to1[13][4] = -0.182195014163296;
  fWeightMatrix0to1[0][5] = -0.0709903246434197;
  fWeightMatrix0to1[1][5] = -0.342067162085034;
  fWeightMatrix0to1[2][5] = -0.0132493407330607;
  fWeightMatrix0to1[3][5] = -0.00823470642460616;
  fWeightMatrix0to1[4][5] = 0.327550798174883;
  fWeightMatrix0to1[5][5] = 0.0139330142722666;
  fWeightMatrix0to1[6][5] = -0.143445818646723;
  fWeightMatrix0to1[7][5] = 0.245436522819637;
  fWeightMatrix0to1[8][5] = 0.27869716652136;
  fWeightMatrix0to1[9][5] = 0.0404991772350732;
  fWeightMatrix0to1[10][5] = 0.0920054597205085;
  fWeightMatrix0to1[11][5] = -0.0251500300237098;
  fWeightMatrix0to1[12][5] = 0.0561489498084528;
  fWeightMatrix0to1[13][5] = 0.0106218188145911;
  fWeightMatrix0to1[0][6] = -0.0366587415239879;
  fWeightMatrix0to1[1][6] = 0.0817400776019436;
  fWeightMatrix0to1[2][6] = -0.0790983346049311;
  fWeightMatrix0to1[3][6] = 0.321759573048747;
  fWeightMatrix0to1[4][6] = -0.87461331572319;
  fWeightMatrix0to1[5][6] = -0.0333615748897274;
  fWeightMatrix0to1[6][6] = -0.319228128030401;
  fWeightMatrix0to1[7][6] = 0.0744315177508446;
  fWeightMatrix0to1[8][6] = 0.687389759600666;
  fWeightMatrix0to1[9][6] = 0.109821913577572;
  fWeightMatrix0to1[10][6] = -0.470577365497736;
  fWeightMatrix0to1[11][6] = 0.0471407037337533;
  fWeightMatrix0to1[12][6] = -0.164464374367461;
  fWeightMatrix0to1[13][6] = -0.545653995063277;
  fWeightMatrix0to1[0][7] = -0.017962684801526;
  fWeightMatrix0to1[1][7] = -0.166558239007876;
  fWeightMatrix0to1[2][7] = 0.000408579890866868;
  fWeightMatrix0to1[3][7] = 0.0475922980008954;
  fWeightMatrix0to1[4][7] = 0.326942730088735;
  fWeightMatrix0to1[5][7] = 0.00259442147177166;
  fWeightMatrix0to1[6][7] = -0.0705842940793564;
  fWeightMatrix0to1[7][7] = 0.074805951505163;
  fWeightMatrix0to1[8][7] = 0.113321038703995;
  fWeightMatrix0to1[9][7] = -0.0293399584045551;
  fWeightMatrix0to1[10][7] = 0.223847627107861;
  fWeightMatrix0to1[11][7] = 0.00296668081942377;
  fWeightMatrix0to1[12][7] = 0.0028948604998385;
  fWeightMatrix0to1[13][7] = -0.0213413927061029;
  fWeightMatrix0to1[0][8] = -0.0265260895480864;
  fWeightMatrix0to1[1][8] = 0.0181647720543232;
  fWeightMatrix0to1[2][8] = -0.0692662269237608;
  fWeightMatrix0to1[3][8] = 0.0678268025834353;
  fWeightMatrix0to1[4][8] = -0.00606675028130116;
  fWeightMatrix0to1[5][8] = -0.00982717366810707;
  fWeightMatrix0to1[6][8] = -0.031962668180472;
  fWeightMatrix0to1[7][8] = -0.00920181101289577;
  fWeightMatrix0to1[8][8] = -0.127901022585868;
  fWeightMatrix0to1[9][8] = -0.0191826651109264;
  fWeightMatrix0to1[10][8] = -0.0612315390829003;
  fWeightMatrix0to1[11][8] = 0.155242372547931;
  fWeightMatrix0to1[12][8] = -0.0545142876609985;
  fWeightMatrix0to1[13][8] = 0.0416066001666382;
  fWeightMatrix0to1[0][9] = -0.0263097632155853;
  fWeightMatrix0to1[1][9] = 0.527757487904598;
  fWeightMatrix0to1[2][9] = -0.0280047710083223;
  fWeightMatrix0to1[3][9] = -0.0680874973131969;
  fWeightMatrix0to1[4][9] = 0.121615542030817;
  fWeightMatrix0to1[5][9] = 0.0455887923518735;
  fWeightMatrix0to1[6][9] = 0.201192648232723;
  fWeightMatrix0to1[7][9] = -0.121184019273481;
  fWeightMatrix0to1[8][9] = -0.187316407731116;
  fWeightMatrix0to1[9][9] = 0.0762639395764055;
  fWeightMatrix0to1[10][9] = 0.145794522588386;
  fWeightMatrix0to1[11][9] = 0.195958110126408;
  fWeightMatrix0to1[12][9] = 0.302912221873902;
  fWeightMatrix0to1[13][9] = 0.439486271844709;
  // weight matrix from layer 1 to 2
  fWeightMatrix1to2[0][0] = 0.84626808984774;
  fWeightMatrix1to2[0][1] = -7.37260236614955;
  fWeightMatrix1to2[0][2] = 2.39174280084124;
  fWeightMatrix1to2[0][3] = -5.36439486641885;
  fWeightMatrix1to2[0][4] = -6.57685548039174;
  fWeightMatrix1to2[0][5] = 0.710207900975816;
  fWeightMatrix1to2[0][6] = 3.35939263203118;
  fWeightMatrix1to2[0][7] = -2.21792831362249;
  fWeightMatrix1to2[0][8] = -5.36793102286721;
  fWeightMatrix1to2[0][9] = -5.30302769222427;
  fWeightMatrix1to2[0][10] = -5.48961463726794;
  fWeightMatrix1to2[0][11] = 5.73814628733488;
  fWeightMatrix1to2[0][12] = 3.69836435902006;
  fWeightMatrix1to2[0][13] = 5.6043354593103;
  fWeightMatrix1to2[0][14] = 0.384853505978876;
}

inline double ReadMLPBNN::GetMvaValue__( const std::array<double,9>& inputValues ) const
{
  if (UNLIKELY(inputValues.size() != (unsigned int)fLayerSize[0]-1)) {
    std::cout << "Input vector needs to be of size " << fLayerSize[0]-1 << std::endl;
    return 0;
  }

  for (int l=0; l<fLayers; l++)
    for (int i=0; i<fLayerSize[l]; i++) fWeights[l][i]=0;

  for (int l=0; l<fLayers-1; l++)
    fWeights[l][fLayerSize[l]-1]=1;

  for (int i=0; i<fLayerSize[0]-1; i++)
    fWeights[0][i]=inputValues[i];

  // layer 0 to 1
  for (int o=0; o<fLayerSize[1]-1; o++) {
    for (int i=0; i<fLayerSize[0]; i++) {
      double inputVal = fWeightMatrix0to1[o][i] * fWeights[0][i];
      fWeights[1][o] += inputVal;
    }
    fWeights[1][o] = ActivationFnc(fWeights[1][o]);
  }
  // layer 1 to 2
  for (int o=0; o<fLayerSize[2]; o++) {
    for (int i=0; i<fLayerSize[1]; i++) {
      double inputVal = fWeightMatrix1to2[o][i] * fWeights[1][i];
      fWeights[2][o] += inputVal;
    }
    fWeights[2][o] = OutputActivationFnc(fWeights[2][o]);
  }

  return fWeights[2][0];
}

inline double ReadMLPBNN::ActivationFnc(double x) const {
  // rectified linear unit
  return x>0 ? x : 0; 
}
inline double ReadMLPBNN::OutputActivationFnc(double x) const {
  // sigmoid
  return 1.0/(1.0+vdt::fast_exp(-x));
}
   
// Clean up
inline void ReadMLPBNN::Clear() 
{
  // clean up the arrays
  for (int lIdx = 0; lIdx < 3; lIdx++) {
    delete[] fWeights[lIdx];
  }
}
inline double ReadMLPBNN::GetMvaValue( const std::array<double,9>& inputValues ) const
{
  // classifier response value
  double retval = 0;
  
  // classifier response, sanity check first
  if (UNLIKELY(!IsStatusClean())) {
    std::cout << "Problem in class \"" << fClassName << "\": cannot return classifier response"
              << " because status is dirty" << std::endl;
    retval = 0;
  }
  else {
    if (IsNormalised()) {
      // normalise variables
      std::array<double,9> iV;
      int ivar = 0;
      for (std::array<double,9>::const_iterator varIt = inputValues.begin();
           varIt != inputValues.end(); varIt++, ivar++) {
        iV[ivar] = NormVariable( *varIt, fVmin[ivar], fVmax[ivar] );
      }
      Transform( iV, -1 );
      retval = GetMvaValue__( iV );
    }
    else {
      std::array<double,9> iV = inputValues;
      Transform( iV, -1 );
      retval = GetMvaValue__( iV );
    }
  }
  
  return retval;
}

//_______________________________________________________________________
inline void ReadMLPBNN::InitTransform_1()
{
  // Normalization transformation, initialisation
  fMin_1[0][0] = -4.06751394272;
  fMax_1[0][0] = 3.89407348633;
  fMin_1[1][0] = -4.2236661911;
  fMax_1[1][0] = 3.9046216011;
  fMin_1[2][0] = -4.2236661911;
  fMax_1[2][0] = 3.9046216011;
  fMin_1[0][1] = 7.27931213379;
  fMax_1[0][1] = 11.3994436264;
  fMin_1[1][1] = 7.24498987198;
  fMax_1[1][1] = 11.9081087112;
  fMin_1[2][1] = 7.24498987198;
  fMax_1[2][1] = 11.9081087112;
  fMin_1[0][2] = 3.85917401314;
  fMax_1[0][2] = 8.18527698517;
  fMin_1[1][2] = 3.3211350441;
  fMax_1[1][2] = 8.50529193878;
  fMin_1[2][2] = 3.3211350441;
  fMax_1[2][2] = 8.50529193878;
  fMin_1[0][3] = 2.08142009797e-05;
  fMax_1[0][3] = 0.229948401451;
  fMin_1[1][3] = 1.30815415105e-05;
  fMax_1[1][3] = 0.280173331499;
  fMin_1[2][3] = 1.30815415105e-05;
  fMax_1[2][3] = 0.280173331499;
  fMin_1[0][4] = -4.81101942062;
  fMax_1[0][4] = 4.85316181183;
  fMin_1[1][4] = -4.96382665634;
  fMax_1[1][4] = 4.9918179512;
  fMin_1[2][4] = -4.96382665634;
  fMax_1[2][4] = 4.9918179512;
  fMin_1[0][5] = -7.98678255081;
  fMax_1[0][5] = 4.29306793213;
  fMin_1[1][5] = -5.11446094513;
  fMax_1[1][5] = 4.8268237114;
  fMin_1[2][5] = -7.98678255081;
  fMax_1[2][5] = 4.8268237114;
  fMin_1[0][6] = -4.14395427704;
  fMax_1[0][6] = 5.70368623734;
  fMin_1[1][6] = -8.60095500946;
  fMax_1[1][6] = 5.82908582687;
  fMin_1[2][6] = -8.60095500946;
  fMax_1[2][6] = 5.82908582687;
  fMin_1[0][7] = -4.1739859581;
  fMax_1[0][7] = 5.46751737595;
  fMin_1[1][7] = -5.93340778351;
  fMax_1[1][7] = 5.69148921967;
  fMin_1[2][7] = -5.93340778351;
  fMax_1[2][7] = 5.69148921967;
  fMin_1[0][8] = 3;
  fMax_1[0][8] = 4;
  fMin_1[1][8] = 3;
  fMax_1[1][8] = 4;
  fMin_1[2][8] = 3;
  fMax_1[2][8] = 4;
}

//_______________________________________________________________________
inline void ReadMLPBNN::Transform_1( std::array<double,9>& iv, int cls) const
{
  // Normalization transformation
  if (cls < 0 || cls > 2) {
    cls = 2;
  }
  const int nVar = 9;

  // get indices of used variables

  // define the indices of the variables which are transformed by this transformation
  static std::vector<int> indicesGet;
  static std::vector<int> indicesPut;

  if ( indicesGet.empty() ) { 
    indicesGet.reserve(fNvars);
    indicesGet.push_back( 0);
    indicesGet.push_back( 1);
    indicesGet.push_back( 2);
    indicesGet.push_back( 3);
    indicesGet.push_back( 4);
    indicesGet.push_back( 5);
    indicesGet.push_back( 6);
    indicesGet.push_back( 7);
    indicesGet.push_back( 8);
  } 
  if ( indicesPut.empty() ) { 
    indicesPut.reserve(fNvars);
    indicesPut.push_back( 0);
    indicesPut.push_back( 1);
    indicesPut.push_back( 2);
    indicesPut.push_back( 3);
    indicesPut.push_back( 4);
    indicesPut.push_back( 5);
    indicesPut.push_back( 6);
    indicesPut.push_back( 7);
    indicesPut.push_back( 8);
  } 

  static std::vector<double> dv;
  dv.resize(nVar);
  for (int ivar=0; ivar<nVar; ivar++) dv[ivar] = iv[indicesGet.at(ivar)];
  for (int ivar=0;ivar<9;ivar++) {
    double offset = fMin_1[cls][ivar];
    double scale  = 1.0/(fMax_1[cls][ivar]-fMin_1[cls][ivar]);
    iv[indicesPut.at(ivar)] = (dv[ivar]-offset)*scale * 2 - 1;
  }
}

//_______________________________________________________________________
inline void ReadMLPBNN::InitTransform()
{
  InitTransform_1();
}

//_______________________________________________________________________
inline void ReadMLPBNN::Transform( std::array<double,9>& iv, int sigOrBgd ) const
{
  Transform_1( iv, sigOrBgd );
}
